/*****************************************************************************
*
* FILE NAME:		EgDBA.cpp
*
* DESCRIPTION:		RT-edge DBRei CvOW[
*
*                   Copyright(C) 2020 Micronet Co. All Rights Reserved.
\*****************************************************************************/

#include "EgDBA.h"
#include "ThreadTimer.h"
#include "ThreadDB.h"


// O[oϐ
RTHANDLE			hRootProcess;							// [gvZX
DWORD				dwKtickInUsecs;							// ჌xeBbNl
INIT_STRUCT			gInit;									// O[oIuWFNg
DWORD				dwDebugFlag;							// fobOtO
BYTE				byDBType;								// SQL
string				srDBConDsn;								// DBڑf[^\[X
string				srDBConDbName;							// DBڑT[rX/f[^x[X
string				srDBConUser;							// DBڑOC[U
string				srDBConPass;							// DBڑ[UpX[h
WORD				woDBConTO;								// DBڑ^CAEg

// T[rXCWP[^
CEgDBATag			m_tgIndStatus;							// T[rXCWP[^FT[rX̋N
CEgDBATag			m_tgIndError;							// T[rXCWP[^FT[rXG[

// T[rXvpeB^O
CEgDBATag			m_tgMode;								// 샂[h
CEgDBATag			m_tgAutoRun;							// ^OtbVݒ
CEgDBATag			m_tgCycle;								// ^OtbV
CEgDBATag			m_tgTimerPri;							// ^C}[Xbh̃vCIeB
CEgDBATag			m_tgDBPri;								// DBXbh̃vCIeB
CEgDBATag			m_tgTagCheckTimeout;					// ^Oo^`FbN^CAEg(b)
CEgDBATag			m_tgTableDelete;						// DBe[u݂ꍇ̏
CEgDBATag			m_tgTableUnmatch;						// DBe[u\sv̏ꍇ̏
CEgDBATag			m_tgTableRecMax;						// DBe[uő[

CEgDBATag			m_tgLastErrMain;						// CXbhFŐṼG[R[h
CEgDBATag			m_tgSuspendCallback;					// R[obNFN
CEgDBATag			m_tgLastErrCallback;					// R[obNFŐṼG[R[h
CEgDBATag			m_tgMsgStop;							// R[obNFSTOPM
CEgDBATag			m_tgMsgRun;								// R[obNFRUNM
CEgDBATag			m_tgMsgPause;							// R[obNFPAUSEM
CEgDBATag			m_tgMsgUpdate;							// R[obNFUPDATEM
CEgDBATag			m_tgMsgUnknown;							// R[obNFT|[gM
CEgDBATag			m_tgTrgCallback;						// R[obNFDBsʒm


CEgDBALog			m_Log;									// O

CThreadTimer		m_thTimer;								// ^C}[Xbh
CThreadDB			m_thDB;									// DBXbh


void				Cleanup(void);
void				Fail(LPSTR lpszMessage, ...);

char SERVICE_REAL_NAME[EG_MAX_SERVICENAME + 1] = { 0 };		// T[rX
/// <summary>
/// T[rXJ^O
/// </summary>
char SERVICE_CATALOG_NAME[EG_MAX_CATALOGNAME] = { 0 };		// J^O

// ------------------------------------------------------------
// RXgN^
CEgDBATag::CEgDBATag(void)
{
	m_srName = "";
	m_woType = 0;
	m_woSize = 0;
}

// ------------------------------------------------------------
// fXgN^
CEgDBATag::~CEgDBATag(void)
{
}

// ------------------------------------------------------------
// ^O̐
void	CEgDBATag::fnCreateName(const char *chName, bool boPrefix)
{
	// w肳ꂽ^ȎOɁuSERVICE.EgDBAvtL̔
	if (true == boPrefix)
	{
		// w肳ꂽ^ȎOɁuSERVICE.EgDBAvt
		m_srName.Format("SERVICE.%s.%s", ServiceRealName, chName);
	}
	else
	{
		// w肳ꂽ^ȎOɁuSERVICE.EgDBAvtȂ
		m_srName.Format("%s", chName);
	}
}

// ------------------------------------------------------------
// ^O̐
DWORD	CEgDBATag::fnCreate(const char *chName, WORD woType, const char *chSource, const char *chComment, bool boPrefix)
{
	DWORD			dwRet;				// ߂l

	// ^O̐
	fnCreateName(chName, boPrefix);
	// ^Of[^̏
	m_unData.qwVal = 0;
	// ^O^Cv̐ݒ
	m_woType = woType;
	// ^OTCY̐ݒ
	m_woSize = fnGetSize(woType);
	// ^O̐
	dwRet = EgTagCreateEx(m_srName.c_str(), woType, chSource, chComment);
	if (EDGE_SUCCESS == dwRet) {							// ^O̐
		m_Log.m_srMsg.Format("TagCreate %s", m_srName.c_str());
		m_Log.fnPirnt(EG_LOG_DBG, __LINE__);
		// ^Ȍ	
		dwRet = fnWrite();
	}
	else if (dwRet == EDGE_TTABLE_ISEXIST_TAGNAME) {		// o^ς
		m_Log.m_srMsg.Format("TagCreate %s already exist", m_srName.c_str());
		m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
		// ^O̓ǂݍ
		dwRet = fnRead();
	}
	else {													// ^O̐s
		m_Log.m_srMsg.Format("TagCreate %s 0x%08X", m_srName.c_str(), dwRet);
		m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
	}

	return dwRet;
}

// ------------------------------------------------------------
// ^O̐ݒ
DWORD	CEgDBATag::fnAttach(const char *chName, bool boPrefix)
{
	DWORD			dwRet;				// ߂l

	// ^O̐
	fnCreateName(chName, boPrefix);
	// ^O^Cv̎擾
	dwRet = EgTagGetProperty(m_srName.c_str(), "Type", &m_woType, sizeof(m_woType));
	// ^Of[^TCY̎擾
	dwRet = EgTagGetProperty(m_srName.c_str(), "Size", &m_woSize, sizeof(m_woSize));
	// 擾ʔ
	if (0 == dwRet) {					// 擾
		dwRet = fnRead();				// ^O̓ǂݍ
	}
	return dwRet;
}

// ------------------------------------------------------------
// ^OTCY̎擾
WORD	CEgDBATag::fnGetSize(WORD woType)
{
	WORD			woSize;				// ^OTCY

	switch (woType) {
		// ^Cv			^OTCY
	case	EgVtBoolean:	woSize = 1;	break;
	case	EgVtSByte:		woSize = 1;	break;
	case	EgVtByte:		woSize = 1;	break;
	case	EgVtInt16:		woSize = 2;	break;
	case	EgVtUInt16:		woSize = 2;	break;
	case	EgVtInt32:		woSize = 4;	break;
	case	EgVtUInt32:		woSize = 4;	break;
	case	EgVtInt64:		woSize = 8;	break;
	case	EgVtUInt64:		woSize = 8;	break;
	case	EgVtFloat:		woSize = 4;	break;
	case	EgVtDouble:		woSize = 8;	break;
	default:				woSize = 0;	break;
	}

	return woSize;
}

// ------------------------------------------------------------
// ^O̓ǂݍ
DWORD	CEgDBATag::fnRead()
{
	DWORD			dwRet = EDGE_SUCCESS;					// ߂l

	dwRet = EgTagRead(m_srName.c_str(), &m_unData.qwVal, m_woSize);

	return dwRet;
}

// ------------------------------------------------------------
// ^Ȍ
DWORD	CEgDBATag::fnWrite()
{
	DWORD			dwRet = EDGE_SUCCESS;					// ߂l

	dwRet = EgTagWrite(m_srName.c_str(), &m_unData.qwVal, m_woSize);

	return dwRet;
}



// ------------------------------------------------------------
// RXgN^
CEgDBALog::CEgDBALog(void)
{
}

// ------------------------------------------------------------
// fXgN^
CEgDBALog::~CEgDBALog(void)
{
}

// ------------------------------------------------------------
void CEgDBALog::fnPirnt(const char *chMode, DWORD dwLine)
{
	// RT-edgeOo
	EgFW_PrintLog(SERVICE_REAL_NAME, chMode, "[%04d]%s %s", dwLine, m_srObj.c_str(), m_srMsg.c_str());

	IFPp{													// R\[o͂
		// [hŕ
		if (strcmp(chMode, EG_LOG_WRN) == 0) {				// [jO
			// 擪"W$"t
			printf("W$[%04d]%s %s\n", dwLine, m_srObj.c_str(), m_srMsg.c_str());
		}
		else if ((strcmp(chMode, EG_LOG_ERR) == 0) ||		// G[ 
				 (strcmp(chMode, EG_LOG_FER) == 0)) {		// FATAL ERROR
			// 擪"E$"t
			printf("E$[%04d]%s %s\n", dwLine, m_srObj.c_str(), m_srMsg.c_str());
		}
		else {												// ȊO
			// 擪"I$"t
			printf("I$[%04d]%s %s\n", dwLine, m_srObj.c_str(), m_srMsg.c_str());
		}
	}
}



/*****************************************************************************
* split
* w蕶ŕ𕪊
* p[^
* char *str			:镶
* const char *delim	:镶
* char *outlist[]	:i[obt@
* int MaxInde		:i[obt@z
* ߂l
******************************************************************************/
int split(char *str, const char *delim, char *outlist[], int MaxIndex) {
	char    *tk;
	int     cnt = 0;

	tk = strtok(str, delim);
	while (tk != NULL && cnt < MaxIndex) {
		outlist[cnt++] = tk;
		tk = strtok(NULL, delim);
	}
	return cnt;
}


// ------------------------------------------------------------
// T[rXCWP[^ECXbhŎgp^O̐
// [param]
//		Ȃ
// [return]
//		0=I/ȊO=G[
// [remarks]
//		Ȃ
// ------------------------------------------------------------
DWORD fnCreateTagMain()
{
	// T[rXCWP[^FT[rX̋N
	m_tgIndStatus.fnAttach("Status");

	// T[rXCWP[^FT[rXG[
	m_tgIndError.fnAttach("Error");

	// CXbhFŐṼG[R[h
	m_tgLastErrMain.fnCreate("LastErr.Main", EgVtUInt32, "", "");

	return ERR_EGDBA_OK;										// I
}


// ------------------------------------------------------------
// T[rXRtBOt@C̓ǂݍ݁FT[rXvpeB
// [param]
//		Ȃ
// [return]
//		0=I/ȊO=G[
// [remarks]
//		Ȃ
// ------------------------------------------------------------
DWORD fnReadEgDBASerivce()
{
	DWORD			dwRet;

	// ------------------------------------------------------------
	// ^O̓ǂݍ݁FMODBUS/TCPX[uƂ̓샂[h
	dwRet = m_tgMode.fnAttach("Mode");
	// ʔ
	if (0 == dwRet) {											// ǂݍݐ
		// ͈̓`FbN
		switch (m_tgMode.m_unData.byVal) {
		case	EN_EGDBA_MODE_CYCLE:					break;	// TCN
		case	EN_EGDBA_MODE_DEMAND:					break;	// f}h
		default:												// ȊOFT|[g
			m_Log.m_srMsg.Format("%s out of range %d", m_tgMode.m_srName.c_str(), m_tgMode.m_unData.byVal);
			m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
			m_tgMode.m_unData.byVal = EN_EGDBA_MODE_DEMAND;		// ͈͊Ô߃ftHglZbg
			m_tgMode.fnWrite();									// ^Ȍ
			break;
		}
	}
	else {														// ǂݍݎs
		m_Log.m_srMsg.Format("attach error %s 0x%08X", m_tgMode.m_srName.c_str(), dwRet);
		m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
		m_tgMode.fnCreate("Mode", EgVtByte, "", "EgDBA Mode");	// ^O̍쐬
		m_tgMode.m_unData.byVal = EN_EGDBA_MODE_DEMAND;			// ftHglZbg
		m_tgMode.fnWrite();										// ^Ȍ
	}
	m_Log.m_srMsg.Format("%s %d", m_tgMode.m_srName.c_str(), m_tgMode.m_unData.byVal);
	m_Log.fnPirnt(EG_LOG_DBG, __LINE__);

	// ------------------------------------------------------------
	// ^O̓ǂݍ݁F^OtbVݒ
	dwRet = m_tgAutoRun.fnAttach("AutoRun");
	// ʔ
	if (0 == dwRet) {											// ǂݍݐ
		// ͈̓`FbN
		switch (m_tgAutoRun.m_unData.boVal) {
		case	TRUE:									break;
		case	FALSE:									break;
		default:												// ȊOFT|[g
			m_Log.m_srMsg.Format("%s out of range %d", m_tgAutoRun.m_srName.c_str(), m_tgAutoRun.m_unData.boVal);
			m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
			m_tgAutoRun.m_unData.boVal = FALSE;					// ͈͊Ô߃ftHglZbg
			m_tgAutoRun.fnWrite();								// ^Ȍ
			break;
		}
	}
	else {														// ǂݍݎs
		m_Log.m_srMsg.Format("attach error %s 0x%08X", m_tgAutoRun.m_srName.c_str(), dwRet);
		m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
		m_tgAutoRun.fnCreate("AutoRun", EgVtBoolean, "", "EgDBA Auto Tag Refresh");	// ^O̍쐬
		m_tgAutoRun.m_unData.boVal = FALSE;						// ftHglZbg
		m_tgAutoRun.fnWrite();									// ^Ȍ
	}
	m_Log.m_srMsg.Format("%s %d", m_tgAutoRun.m_srName.c_str(), m_tgAutoRun.m_unData.boVal);
	m_Log.fnPirnt(EG_LOG_DBG, __LINE__);

	// ------------------------------------------------------------
	// ^O̓ǂݍ݁F^OtbV
	dwRet = m_tgCycle.fnAttach("Cycle");
	// ʔ
	if (0 == dwRet) {											// ǂݍݐ
		// ͈̓`FbN
		if (MIN_CYCLE > m_tgCycle.m_unData.dwVal) {
			m_Log.m_srMsg.Format("%s out of range %d", m_tgCycle.m_srName.c_str(), m_tgCycle.m_unData.dwVal);
			m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
			m_tgCycle.m_unData.dwVal = DEF_CYCLE;				// ͈͊Ô߃ftHglZbg
			m_tgCycle.fnWrite();								// ^Ȍ
		}
	}
	else {														// ǂݍݎs
		m_Log.m_srMsg.Format("attach error %s 0x%08X", m_tgCycle.m_srName.c_str(), dwRet);
		m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
		m_tgCycle.fnCreate("Cycle", EgVtUInt32, "", "EgDBA In/Out Interval(ms)");	// ^O̍쐬
		m_tgCycle.m_unData.dwVal = DEF_CYCLE;					// ftHglZbg
		m_tgCycle.fnWrite();									// ^Ȍ
	}
	m_Log.m_srMsg.Format("%s %d", m_tgCycle.m_srName.c_str(), m_tgCycle.m_unData.dwVal);
	m_Log.fnPirnt(EG_LOG_DBG, __LINE__);

	// ------------------------------------------------------------
	// ^O̓ǂݍ݁F^C}[Xbh̃vCIeB
	dwRet = m_tgTimerPri.fnAttach("TimerPriority");
	// ʔ
	if (0 == dwRet) {											// ǂݍݐ
		// ͈̓`FbN
		if ((MIN_TIMER_PRI > m_tgTimerPri.m_unData.byVal) ||
			(MAX_TIMER_PRI < m_tgTimerPri.m_unData.byVal)) {
			m_Log.m_srMsg.Format("%s out of range %d", m_tgTimerPri.m_srName.c_str(), m_tgTimerPri.m_unData.byVal);
			m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
			m_tgTimerPri.m_unData.byVal = DEF_TIMER_PRI;		// ͈͊Ô߃ftHglZbg
			m_tgTimerPri.fnWrite();								// ^Ȍ
		}
	}
	else {														// ǂݍݎs
		m_Log.m_srMsg.Format("attach error %s 0x%08X", m_tgTimerPri.m_srName.c_str(), dwRet);
		m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
		m_tgTimerPri.fnCreate("TimerPriority", EgVtByte, "", "EgDBA Timer Thread Priority");	// ^O̍쐬
		m_tgTimerPri.m_unData.byVal = DEF_TIMER_PRI;			// ftHglZbg
		m_tgTimerPri.fnWrite();									// ^Ȍ
	}
	m_Log.m_srMsg.Format("%s %d", m_tgTimerPri.m_srName.c_str(), m_tgTimerPri.m_unData.byVal);
	m_Log.fnPirnt(EG_LOG_DBG, __LINE__);

	// ------------------------------------------------------------
	// ^O̓ǂݍ݁FDBXbh̃vCIeB
	dwRet = m_tgDBPri.fnAttach("DBPriority");
	// ʔ
	if (0 == dwRet) {											// ǂݍݐ
		// ͈̓`FbN
		if ((MIN_DB_PRI > m_tgDBPri.m_unData.byVal) ||
			(MAX_DB_PRI < m_tgDBPri.m_unData.byVal)) {
			m_Log.m_srMsg.Format("%s out of range %d", m_tgDBPri.m_srName.c_str(), m_tgDBPri.m_unData.byVal);
			m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
			m_tgDBPri.m_unData.byVal = DEF_DB_PRI;				// ͈͊Ô߃ftHglZbg
			m_tgDBPri.fnWrite();								// ^Ȍ
		}
	}
	else {														// ǂݍݎs
		m_Log.m_srMsg.Format("attach error %s 0x%08X", m_tgDBPri.m_srName.c_str(), dwRet);
		m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
		m_tgDBPri.fnCreate("DBPriority", EgVtByte, "", "EgDBA DB Thread Priority");	// ^O̍쐬
		m_tgDBPri.m_unData.byVal = DEF_DB_PRI;			// ftHglZbg
		m_tgDBPri.fnWrite();									// ^Ȍ
	}
	m_Log.m_srMsg.Format("%s %d", m_tgDBPri.m_srName.c_str(), m_tgDBPri.m_unData.byVal);
	m_Log.fnPirnt(EG_LOG_DBG, __LINE__);

	// ------------------------------------------------------------
	// ^O̓ǂݍ݁F^Oo^`FbN^CAEg(b)
	dwRet = m_tgTagCheckTimeout.fnAttach("TagCheckTimeout");
	// ʔ
	if (0 == dwRet) {											// ǂݍݐ
		// ͈̓`FbN
		if (MIN_TAG_CHECK_TIMEOUT > m_tgTagCheckTimeout.m_unData.dwVal) {
			m_Log.m_srMsg.Format("%s out of range %d", m_tgTagCheckTimeout.m_srName.c_str(), m_tgTagCheckTimeout.m_unData.dwVal);
			m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
			m_tgTagCheckTimeout.m_unData.dwVal = MIN_TAG_CHECK_TIMEOUT;	// ͈͊Ô߃ftHglZbg
			m_tgTagCheckTimeout.fnWrite();								// ^Ȍ
		}
	}
	else {														// ǂݍݎs
		m_Log.m_srMsg.Format("attach error %s 0x%08X", m_tgTagCheckTimeout.m_srName.c_str(), dwRet);
		m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
		m_tgTagCheckTimeout.fnCreate("TagCheckTimeout", EgVtUInt32, "", "EgDBA TagCheckTimeout");	// ^O̍쐬
		m_tgTagCheckTimeout.m_unData.dwVal = MIN_TAG_CHECK_TIMEOUT;		// ftHglZbg
		m_tgTagCheckTimeout.fnWrite();									// ^Ȍ
	}
	m_Log.m_srMsg.Format("%s %d", m_tgTagCheckTimeout.m_srName.c_str(), m_tgTagCheckTimeout.m_unData.dwVal);
	m_Log.fnPirnt(EG_LOG_DBG, __LINE__);

	// ------------------------------------------------------------
	// ^O̓ǂݍ݁FDBe[u݂ꍇ̏
	dwRet = m_tgTableDelete.fnAttach("TableDelete");
	// ʔ
	if (0 == dwRet) {											// ǂݍݐ
		// ͈̓`FbN
		switch (m_tgTableDelete.m_unData.boVal) {
		case	TRUE:									break;
		case	FALSE:									break;
		default:												// ȊOFT|[g
			m_Log.m_srMsg.Format("%s out of range %d", m_tgTableDelete.m_srName.c_str(), m_tgTableDelete.m_unData.boVal);
			m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
			m_tgTableDelete.m_unData.boVal = FALSE;				// ͈͊Ô߃ftHglZbg
			m_tgTableDelete.fnWrite();							// ^Ȍ
			break;
		}
	}
	else {														// ǂݍݎs
		m_Log.m_srMsg.Format("attach error %s 0x%08X", m_tgTableDelete.m_srName.c_str(), dwRet);
		m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
		m_tgTableDelete.fnCreate("TableDelete", EgVtBoolean, "", "true = new create / false = append");	// ^O̍쐬
		m_tgTableDelete.m_unData.boVal = FALSE;					// ftHglZbg
		m_tgTableDelete.fnWrite();								// ^Ȍ
	}
	m_Log.m_srMsg.Format("%s %d", m_tgTableDelete.m_srName.c_str(), m_tgTableDelete.m_unData.boVal);
	m_Log.fnPirnt(EG_LOG_DBG, __LINE__);

	// ------------------------------------------------------------
	// ^O̓ǂݍ݁FDBe[u\sv̏ꍇ̏
	dwRet = m_tgTableUnmatch.fnAttach("TableUnmatch");
	// ʔ
	if (0 == dwRet) {											// ǂݍݐ
		// ͈̓`FbN
		switch (m_tgTableUnmatch.m_unData.boVal) {
		case	TRUE:									break;
		case	FALSE:									break;
		default:												// ȊOFT|[g
			m_Log.m_srMsg.Format("%s out of range %d", m_tgTableUnmatch.m_srName.c_str(), m_tgTableUnmatch.m_unData.boVal);
			m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
			m_tgTableUnmatch.m_unData.boVal = FALSE;			// ͈͊Ô߃ftHglZbg
			m_tgTableUnmatch.fnWrite();							// ^Ȍ
			break;
		}
	}
	else {														// ǂݍݎs
		m_Log.m_srMsg.Format("attach error %s 0x%08X", m_tgTableUnmatch.m_srName.c_str(), dwRet);
		m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
		m_tgTableUnmatch.fnCreate("TableUnmatch", EgVtBoolean, "", "true = new create / false = exit");	// ^O̍쐬
		m_tgTableUnmatch.m_unData.boVal = FALSE;					// ftHglZbg
		m_tgTableUnmatch.fnWrite();								// ^Ȍ
	}
	m_Log.m_srMsg.Format("%s %d", m_tgTableUnmatch.m_srName.c_str(), m_tgTableUnmatch.m_unData.boVal);
	m_Log.fnPirnt(EG_LOG_DBG, __LINE__);

	// ------------------------------------------------------------
	// ^O̓ǂݍ݁FDBe[uő[
	dwRet = m_tgTableRecMax.fnAttach("TableRecMax");
	// ʔ
	if (0 == dwRet) {											// ǂݍݐ
	}
	else {														// ǂݍݎs
		m_Log.m_srMsg.Format("attach error %s 0x%08X", m_tgTableRecMax.m_srName.c_str(), dwRet);
		m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
		m_tgTableRecMax.fnCreate("TableRecMax", EgVtInt32, "", "Table Record Max");	// ^O̍쐬
		m_tgTableRecMax.m_unData.loVal = 0;						// ftHglZbg
		m_tgTableRecMax.fnWrite();								// ^Ȍ
	}
	m_Log.m_srMsg.Format("%s %d", m_tgTableRecMax.m_srName.c_str(), m_tgTableRecMax.m_unData.loVal);
	m_Log.fnPirnt(EG_LOG_DBG, __LINE__);


	return ERR_EGDBA_OK;										// I
}


// ------------------------------------------------------------
// R[obNŎgp^O̐
// [param]
//		Ȃ
// [return]
//		0=I/ȊO=G[
// [remarks]
//		Ȃ
// ------------------------------------------------------------
DWORD fnCreateTagCallback()
{
	// R[obNFN
	m_tgSuspendCallback.fnCreate("Suspend.Callback", EgVtBoolean, "", "true=run/false=suspend");

	// R[obNFŐṼG[R[h
	m_tgLastErrCallback.fnCreate("LastErr.Callback", EgVtUInt32, "", "");

	// R[obNFSTOPM
	m_tgMsgStop.fnCreate("Msg.Stop", EgVtUInt32, "", "");

	// R[obNFRUNM
	m_tgMsgRun.fnCreate("Msg.Run", EgVtUInt32, "", "");

	// R[obNFPAUSEM
	m_tgMsgPause.fnCreate("Msg.Pause", EgVtUInt32, "", "");

	// R[obNFUPDATEM
	m_tgMsgUpdate.fnCreate("Msg.Update", EgVtUInt32, "", "");

	// R[obNFT|[gM
	m_tgMsgUnknown.fnCreate("Msg.Unknown", EgVtUInt32, "", "");

	// R[obNFAbvf[gbZ[WgKʒm
	m_tgTrgCallback.fnCreate("Trigger.Callback", EgVtUInt32, "", "");

	return ERR_EGDBA_OK;										// I
}


// ------------------------------------------------------------
// bZ[Wnhp R[obN֐
// [param]
//		*senderName         ... M[{bNX
//		MessageNo           ... bZ[WNo
//		*pData              ... Mf[^
// [return]
//		0=I/ȊO=G[
// [remarks]
//		Ȃ
// ------------------------------------------------------------
int32_t UserMessageHandler(const char *senderName, int32_t MessageNo, void *pData)
{
	DWORD			dwRet;
	RTHANDLE		hDelMbx;
	DWORD			dwTerminate;

	// ------------------------------------------------------------
	// łȂꍇ̓bZ[WM𖳌ɂ
	if (gInit.state != INIT_DONE) {
		m_Log.m_srMsg.Format("Callback: not availabe. INIT_STATE =%d", gInit.state);
		m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
		return 0;
	}

	// ------------------------------------------------------------
	// MbZ[W̕
	switch (MessageNo)
	{
	case EM_SERVICE_RUN:									// T[rXJnw
		m_Log.m_srMsg.Format("Callback: RUN");
		m_Log.fnPirnt(EG_LOG_MSG, __LINE__);
		m_tgMsgRun.m_unData.dwVal++;						// 񐔃CNg
		m_tgMsgRun.fnWrite();								// ^O
		// 샂[h
		if (EN_EGDBA_MODE_CYCLE == m_tgMode.m_unData.byVal) {					// TCN
			m_tgTrgCallback.m_unData.dwVal++;				// 񐔃CNg
			m_tgTrgCallback.fnWrite();						// ^O
			dwRet = m_thTimer.fnStart();					// ^OtbVJn
			if (0 != dwRet) {								// gKʒms
				m_tgSuspendCallback.m_unData.boVal = TRUE;								// NԍXV
				m_tgSuspendCallback.fnWrite();											// ^O
				m_tgLastErrCallback.m_unData.dwVal = ERR_EGDBA_NOTIFY_TRG_TIMER;		// ŐVG[R[hXV
				m_tgLastErrCallback.fnWrite();											// ^O
			}
		}
		else {																	// f}h
			m_Log.m_srMsg.Format("Cannot change run. Mode is demand");
			m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
		}
		break;

	case EM_SERVICE_STOP:									// T[rXIw
		m_Log.m_srMsg.Format("Callback: STOP");
		m_Log.fnPirnt(EG_LOG_MSG, __LINE__);
		m_tgMsgStop.m_unData.dwVal++;						// 񐔃CNg
		m_tgMsgStop.fnWrite();								// ^O
		m_thTimer.fnStop();									// ^OtbV~
		// CXbhɑ΂N[Abvv܂
		hDelMbx = LookupRtHandle(NULL_RTHANDLE, "R?EXIT_MBOX", 5000);
		dwTerminate = TERMINATE;
		SendRtData(hDelMbx, &dwTerminate, 4);
		break;

	case EM_SERVICE_PAUSE:									// T[rXꎞ~w
		m_Log.m_srMsg.Format("Callback: PAUSE");
		m_Log.fnPirnt(EG_LOG_MSG, __LINE__);
		m_tgMsgPause.m_unData.dwVal++;						// 񐔃CNg
		m_tgMsgPause.fnWrite();								// ^O
		m_thTimer.fnStop();									// ^OtbV~
		break;

	case EM_SERVICE_UPDATE:									// T[rXAbvf[gw
		m_Log.m_srMsg.Format("Callback: UPDATE");
		m_Log.fnPirnt(EG_LOG_MSG, __LINE__);
		m_tgMsgUpdate.m_unData.dwVal++;						// 񐔃CNg
		m_tgMsgUpdate.fnWrite();							// ^O
		m_tgTrgCallback.m_unData.dwVal++;					// 񐔃CNg
		m_tgTrgCallback.fnWrite();							// ^O
		dwRet = m_thTimer.fnUpdate();						// ^OtbVXV
		if (0 != dwRet) {									// gKʒms
			m_tgSuspendCallback.m_unData.boVal = TRUE;								// NԍXV
			m_tgSuspendCallback.fnWrite();											// ^O
			m_tgLastErrCallback.m_unData.dwVal = ERR_EGDBA_NOTIFY_TRG_TIMER;		// ŐVG[R[hXV
			m_tgLastErrCallback.fnWrite();											// ^O
		}
		break;

	default:												// ȊO
		m_Log.m_srMsg.Format("Callback: UNKNOWN %d", MessageNo);
		m_Log.fnPirnt(EG_LOG_MSG, __LINE__);
		m_tgMsgUnknown.m_unData.dwVal++;					// 񐔃CNg
		m_tgMsgUnknown.fnWrite();							// ^O
		m_tgLastErrCallback.m_unData.dwVal = ERR_EGDBA_RECV_MSG_UNKNOWN;		// ŐVG[R[hXV
		m_tgLastErrCallback.fnWrite();											// ^O
		break;
	}

	return 0;												// I0 0ȊOُ͈I
}


// ------------------------------------------------------------
// N̐ݒ
// [param]
//		argc    ... Nz
//		*argv[] ... N
// [return]
//		0=I/ȊO=G[
// [remarks]
//		Ȃ
// ------------------------------------------------------------
DWORD fnSetArg(int argc, char* argv[])
{
	DWORD	dwRet = ERR_EGDBA_OK;	// ߂l
	char	chVal[1024];			// 1Np[^i[obt@
	char	*chValArr[10];			// i[obt@
	int		inBunCnt;				// 

	// ftHgf[^Zbg
	dwDebugFlag = 0;
	byDBType = EN_EGDBA_SQL_TYPE_MDB;
	srDBConDsn = "";
	srDBConDbName = "";
	srDBConUser = "";
	srDBConPass = "";
	woDBConTO = DEF_DBCON_TO;

	// f[^i[
	for (auto i = 1; i < argc; i++)
	{
		// ƗpzɊi[
		strcpy(chVal, argv[i]);

		// = ŕ𕪂
		inBunCnt = split(chVal, "=", chValArr, 10);

		// 񕪂?
		if (inBunCnt >= 2) {
			// Ŋi[
			if (strcmp(chValArr[0], "-DebugFlag") == 0) {						// fobOtO
				dwDebugFlag = strtoul(chValArr[1], NULL, 0);
			}
			else if (strcmp(chValArr[0], "Dsn") == 0) {							// DBڑf[^\[X
				srDBConDsn = string(chValArr[1]);
			}
			else if (strcmp(chValArr[0], "DbName") == 0) {						// DBڑT[rX/f[^x[X
				srDBConDbName = string(chValArr[1]);
			}
			else if (strcmp(chValArr[0], "User") == 0) {						// DBڑOC[U
				srDBConUser = string(chValArr[1]);
			}
			else if (strcmp(chValArr[0], "Pass") == 0) {						// DBڑ[UpX[h
				srDBConPass = string(chValArr[1]);
			}
			else if (strcmp(chValArr[0], "TO") == 0) {							// DBڑ^CAEg
				woDBConTO = (WORD)strtoul(chValArr[1], NULL, 0);
			}
		}

		// obt@NA
		memset(chVal, 0, sizeof(chVal));
	}

	// ʔ
	if ("" == srDBConDsn)
	{
		// DBڑf[^\[X̂ݒ肳ĂȂ
		printf("E$[%04d] argument Dsn no set\n", __LINE__);
		dwRet = ERR_EGDBA_DSN_NO_SET;
	}
	if ("" == srDBConDbName)
	{
		// DBڑT[rX/f[^x[X
		printf("E$[%04d] argument DbName no set\n", __LINE__);
		dwRet = ERR_EGDBA_DBNAME_NO_SET;
	}

	return dwRet;
}


/*****************************************************************************
* FUNCTION:		Catalog
*
* PARAMETERS:	1. ǂ̃vWFNgnhgp邩vWFNgnhŎw
*				2. J^OIuWFNgnhw
*				3. J^O閼(pp14ȓ)w
*
* RETURNS:		BOOLEAN Ӗ܂
*
* DESCRIPTION:	^ꂽ̂łɑ݂ĂAvZX[gvZX̏ꍇ
*				ŁAɂłɑ݂閼̂AsȃIuWFNgĂꍇ
*				ȏ𖞂ƂA݂Ă閼͈̂x폜܂B
\*****************************************************************************/
BOOLEAN				Catalog(
	RTHANDLE			hProcess,
	RTHANDLE			hObject,
	LPSTR				lpszName)
{
	RTHANDLE		hOld;

	if (CatalogRtHandle(hProcess, hObject, lpszName))
		return TRUE;

	// 悭G[o܂
	if (((hOld = LookupRtHandle(hProcess, lpszName, NO_WAIT)) != BAD_RTHANDLE) &&
		(GetRtHandleType(hOld) == INVALID_TYPE))
	{
		// ÂGg폜čēx݂܂
		if (UncatalogRtHandle(hProcess, lpszName))
			return (CatalogRtHandle(hProcess, hObject, lpszName));
	}
	return FALSE;
}


/*****************************************************************************
* FUNCTION:   Cleanup (local function)
*
* DESCRIPTION:
*  Xbhɑ΂IɏI悤ɒʒm;
*  ʒmXbh݂ꍇA폜
*  ꂽ̑̃IuWFNg폜B
\*****************************************************************************/
void				Cleanup(void)
{

	// N[Abvł邱Ƃ܂
	gInit.state = CLEANUP_BUSY;
	gInit.bShutdown = TRUE;
	m_Log.m_srMsg.Format("%s started cleaning up", ServiceRealName);
	m_Log.fnPirnt(EG_LOG_OPE, __LINE__);

	// ------------------------------------------------------------
	// T[rXCWP[^sԍXV
	// ------------------------------------------------------------
	m_thTimer.fnStop();										// ^OtbV~

	// ------------------------------------------------------------
	// T[rXCWP[^NԍXV
	// ------------------------------------------------------------
	m_tgIndStatus.m_unData.byVal = 0;							// ~ɍXV
	m_tgIndStatus.fnWrite();									// ^O
	m_Log.m_srMsg.Format("Status %d", m_tgIndStatus.m_unData.byVal);
	m_Log.fnPirnt(EG_LOG_OPE, __LINE__);

	// ------------------------------------------------------------
	// DBؒf
	// ------------------------------------------------------------
	m_thDB.fnClose();

	// [gvZXJ^Ô폜܂
	if (gInit.bCataloged)
		if (!UncatalogRtHandle(hRootProcess, SERVICE_CATALOG_NAME))
			Fail("Cannot remove my own name");

	m_Log.m_srMsg.Format("%s finished cleaning up", ServiceRealName);
	m_Log.fnPirnt(EG_LOG_OPE, __LINE__);

	// ------------------------------------------------------------
	// t[[N̏I
	// ------------------------------------------------------------
	EgFinalize();

	// ------------------------------------------------------------
	// I
	// ------------------------------------------------------------
	exit(0);
}


/*****************************************************************************
* FUNCTION:     	Fail
*
* PARAMETERS:   	printfƓl̃p[^҂܂
*
* DESCRIPTION:
*  fobO[hɂăbZ[Wvg܂BVCǉ
*  XgG[R[hvg܂B̌svZX͍폜܂:
*  JgXbhCXbh̏ꍇAړIɏI܂B
*  JgXbhCXbhȊȌꍇAIv𑗂
*  ̓R[Xbhɖ߂܂
\*****************************************************************************/
void Fail(LPSTR lpszMessage, ...)
{
	EXCEPTION		eh;
	RTHANDLE		hDelMbx;
	DWORD			dwTerminate;

	va_list			ap;

	va_start(ap, lpszMessage);
	vfprintf(stderr, lpszMessage, ap);
	va_end(ap);
	fprintf(stderr, "\nError nr=%x %s\n", GetLastRtError(), GetRtErrorText(GetLastRtError()));

	// OCCpɃ^[邱ƂmFĂ
	GetRtExceptionHandlerInfo(THREAD_HANDLER, &eh);
	eh.ExceptionMode = 0;
	SetRtExceptionHandler(&eh);

	// JnOłꍇAɏI܂
	if (BEFORE_INIT == gInit.state)
		exit(0);

	if (gInit.hMain == GetRtThreadHandles(THIS_THREAD))
	{
		// CXbhłꍇ:
		// łꍇACleanups܂
		if (INIT_BUSY == gInit.state)
			Cleanup();  // ԋp܂

		// CXbh:sĂȂ߁A^[Ƃ܂
		return;
	}

	// CXbhȊO:
	// CXbhɑ΂N[Abvv܂
	// (폜v[𑗂)G[͖܂B
	hDelMbx = LookupRtHandle(NULL_RTHANDLE, "R?EXIT_MBOX", 5000);
	dwTerminate = TERMINATE;
	SendRtData(hDelMbx, &dwTerminate, 4);
}


/*****************************************************************************
*
* FUNCTION:			main
*
* DESCRIPTION:		C
*
*
\*****************************************************************************/
int			main(int argc, char* argv[])
{
	SYSINFO			sysinfo;
	EVENTINFO		eiEventInfo;

	DWORD			dwRet;
	int32_t			inStatus;

	DWORD			dwLp = 0;;								// [vJEg
	BOOL			boThSts;								// TRUE=Xbhς
	DWORD			dwThCheckCnt = 10;						// XbhmFő
	DWORD			dwThCheckWait = 100;					// XbhmF҂(ms)



	// [gvZX擾is܂j
	hRootProcess = GetRtThreadHandles(ROOT_PROCESS);

	// W[\̂NA܂
	memset(&gInit, 0, sizeof(gInit));
	gInit.state = BEFORE_INIT;

	// ჌xeBbNli}CNbj擾܂
	if (!CopyRtSystemInfo(&sysinfo))
		Fail("Cannot copy system info");
	dwKtickInUsecs = 10000 / sysinfo.KernelTickRatio;
	if (dwKtickInUsecs == 0)
		Fail("Invalid low level tick length");

	// vZXővCIeB𒲐܂(s͖)
	// TODO adjust 2Ԗڂ̃p[^𐔒lIɏ邱Ƃł荂vCIeBXbhe܂
	SetRtProcessMaxPriority(NULL_RTHANDLE, 150);

	// CXbh(̊֐)̃nh擾܂
	gInit.hMain = GetRtThreadHandles(THIS_THREAD);
	gInit.state = INIT_BUSY;

	// XbhJ^O݂܂As͖܂
	Catalog(NULL_RTHANDLE, gInit.hMain, NM_EGDBA_THMAIN);

	// OIuWFNg̏
	m_Log.m_srObj.Format("MAIN");

	// N̐ݒ
	dwRet = fnSetArg(argc, argv);
	if (dwRet != ERR_EGDBA_OK)
	{
		Fail("Failed to set argument. Please check argument");
	}

	// ------------------------------------------------------------
	// t[[N̏
	// ------------------------------------------------------------
	EDGECONFIG	egcnfg = EDGE_CONFIG_DEFAULT;
	egcnfg.fpUserMessHdlFunc = UserMessageHandler;			//[U[bZ[Wnhǉ
	inStatus = EgInit(&egcnfg);
	if (inStatus != 0) {
		printf("An error occurred in EgInit. Status = 0x%08X \n", inStatus);
		Fail("Failed to initialize the RT-edge framework. Please check that EgCore.exe is startedin");
	}
	if (strlen(ServiceRealName) > 0)
		memcpy(SERVICE_REAL_NAME, ServiceRealName, sizeof(ServiceRealName));
	else
		memcpy(SERVICE_REAL_NAME, NM_EGDBA_PROC_RTANAME, strlen(NM_EGDBA_PROC_RTANAME));

	memset(SERVICE_CATALOG_NAME, 0, sizeof(SERVICE_CATALOG_NAME));
	sprintf(SERVICE_CATALOG_NAME, "EGSC%s", ServiceMailboxName);// J^O

	// [gvZXɖ{vZXJ^O܂
	if (!Catalog(hRootProcess, GetRtThreadHandles(THIS_PROCESS), SERVICE_CATALOG_NAME))//ServiceRealNamȅꍇÔNG
		Fail("Cannot catalog process name");
	gInit.bCataloged = TRUE;

	// DBڑOo
	m_Log.m_srMsg.Format("DBCon: Dsn=%s DbName=%s User=%s Pass=%s TO=%d", 
							srDBConDsn.c_str(), srDBConDbName.c_str(), srDBConUser.c_str(), srDBConPass.c_str(), woDBConTO );
	m_Log.fnPirnt(EG_LOG_DBG, __LINE__);

	// ------------------------------------------------------------
	// CXbhŎgp^O̐
	// ------------------------------------------------------------
	dwRet = fnCreateTagMain();
	if (ERR_EGDBA_OK != dwRet) {
		// s
		m_Log.m_srMsg.Format("Create main tag 0x%08X", dwRet);
		m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
	}

	// ------------------------------------------------------------
	// T[rXRtBOt@C̓ǂݍ݁FT[rXvpeB
	// ------------------------------------------------------------
	fnReadEgDBASerivce();

	// TagRefs_OUT̔
	if (0 == egTagRefs_OUT_Count)
	{
		// ^OȂ
		m_Log.m_srMsg.Format("Connect Tag is zero");
		m_Log.fnPirnt(EG_LOG_FER, __LINE__);
		m_tgLastErrMain.m_unData.dwVal = ERR_EGDBA_TAG_NO_CONFIG;				// ŐVG[R[hXV
		m_tgLastErrMain.fnWrite();												// ^O
		m_tgIndError.m_unData.boVal = TRUE;										// G[ԍXV
		m_tgIndError.fnWrite();													// ^O
		Fail("Connect Tag is zero. Please check that TagRefs_OUT is defined in EgDBA.xml");
	}

	// ------------------------------------------------------------
	// R[obNŎgp^O̐
	// ------------------------------------------------------------
	dwRet = fnCreateTagCallback();
	if (ERR_EGDBA_OK != dwRet) {
		// s
		m_Log.m_srMsg.Format("Create callback tag 0x%08X", dwRet);
		m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
	}

	// ------------------------------------------------------------
	// vOŒ`T[rXvpeB^O̐F^C}[Xbh
	// ------------------------------------------------------------
	dwRet = m_thTimer.fnCreateTag();
	if (ERR_EGDBA_OK != dwRet) {
		// s
		m_Log.m_srMsg.Format("Create timer tag 0x%08X", dwRet);
		m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
	}

	// ------------------------------------------------------------
	// vOŒ`T[rXvpeB^O̐FDBXbh
	// ------------------------------------------------------------
	dwRet = m_thDB.fnCreateTag();
	if (ERR_EGDBA_OK != dwRet) {
		// s
		m_Log.m_srMsg.Format("Create DB tag 0x%08X", dwRet);
		m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
	}

	// ------------------------------------------------------------
	// T[rXCWP[^NԍXV
	// ------------------------------------------------------------
	m_tgIndStatus.m_unData.byVal = 1;							// NɍXV
	m_tgIndStatus.fnWrite();									// ^O
	m_Log.m_srMsg.Format("Status = %d", m_tgIndStatus.m_unData.byVal);
	m_Log.fnPirnt(EG_LOG_OPE, __LINE__);

	// ------------------------------------------------------------
	// DBXbh̐
	// ------------------------------------------------------------
	dwRet = m_thDB.fnCreateThread(m_tgDBPri.m_unData.byVal);
	if (E_OK != dwRet) {
		// s
		m_Log.m_srMsg.Format("Create DB thread 0x%08X", dwRet);
		m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
		m_tgLastErrMain.m_unData.dwVal = ERR_EGDBA_CREATE_TH_DB;				// ŐVG[R[hXV
		m_tgLastErrMain.fnWrite();												// ^O
	}
	// ------------------------------------------------------------
	// DBXbh̏mF ... w莞ԓɏĂ邩mF
	m_Log.m_srMsg.Format("Check for DB thread");
	m_Log.fnPirnt(EG_LOG_OPE, __LINE__);
	dwLp = 0;
	while (dwLp <= dwThCheckCnt) {
		boThSts = TRUE;										// ftHg͏ς
		// DBXbh̏mF
		if (m_thDB.m_enThSts != INIT_DONE) {				// łȂ
			boThSts = FALSE;								// 
		}
		// ^C~OXbh̏
		if (boThSts == TRUE) {								// 
			break;											// mFI
		}
		else {												// 
			RtSleep(dwThCheckWait);							// wait...
			dwLp++;											// gC
		}
	}
	if (boThSts != TRUE) {
		m_Log.m_srMsg.Format("Check for DB thread. time out");
		m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
		Fail("Failed to check for DB thread. time out");
	}

	// ------------------------------------------------------------
	// DBXbhgK̃bNAbv
	// ------------------------------------------------------------
	dwRet = m_thTimer.fnLookupDBTrg();
	if (ERR_EGDBA_OK != dwRet) {
		// bNAbvs
		m_Log.m_srMsg.Format("Lookup DB trigger 0x%08X", dwRet);
		m_Log.fnPirnt(EG_LOG_FER, __LINE__);
		m_tgIndError.m_unData.boVal = TRUE;										// G[ԍXV
		m_tgIndError.fnWrite();													// ^O
		Fail("Failed to Lookup DB trigger. 0x%08X", dwRet);
	}
	m_thTimer.fnAttachDBTag();

	// ------------------------------------------------------------
	// ^C}[Xbh̐
	// ------------------------------------------------------------
	dwRet = m_thTimer.fnCreateThread(m_tgTimerPri.m_unData.byVal, m_tgCycle.m_unData.dwVal);
	if (E_OK != dwRet) {
		// s
		m_Log.m_srMsg.Format("Create Timer thread 0x%08X", dwRet);
		m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
		m_tgLastErrMain.m_unData.dwVal = ERR_EGDBA_CREATE_TH_TIMER;			// ŐVG[R[hXV
		m_tgLastErrMain.fnWrite();												// ^O
	}
	// ------------------------------------------------------------
	// DBXbh̏mF ... w莞ԓɏĂ邩mF
	m_Log.m_srMsg.Format("Check for Timer thread");
	m_Log.fnPirnt(EG_LOG_OPE, __LINE__);
	dwLp = 0;
	while (dwLp <= dwThCheckCnt) {
		boThSts = TRUE;										// ftHg͏ς
		// DBXbh̏mF
		if (m_thTimer.m_enThSts != INIT_DONE) {				// łȂ
			boThSts = FALSE;								// 
		}
		// ^C~OXbh̏
		if (boThSts == TRUE) {								// 
			break;											// mFI
		}
		else {												// 
			RtSleep(dwThCheckWait);							// wait...
			dwLp++;											// gC
		}
	}
	if (boThSts != TRUE) {
		m_Log.m_srMsg.Format("Check for Timer thread. time out");
		m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
		Fail("Failed to check for Timer thread. time out");
	}

	// Ƃ܂
	gInit.state = INIT_DONE;
	m_Log.m_srMsg.Format("%s finished initialization", ServiceRealName);
	m_Log.fnPirnt(EG_LOG_OPE, __LINE__);

	// ------------------------------------------------------------
	// T[rXʒm
	// ------------------------------------------------------------
	SynchronizeRtLoader();

	// ------------------------------------------------------------
	// ^OtbVN
	// ------------------------------------------------------------
	if ((EN_EGDBA_MODE_CYCLE == m_tgMode.m_unData.byVal) &&			// 샂[hTCN?
		(TRUE == m_tgAutoRun.m_unData.boVal)) {						// ^OtbVݒ肠?
		dwRet = m_thTimer.fnStart();								// ^OtbVJn
		if (0 != dwRet) {											// gKʒms
			m_Log.m_srMsg.Format("Release timer trigger 0x%08X", dwRet);
			m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
			m_tgLastErrCallback.m_unData.dwVal = ERR_EGDBA_NOTIFY_TRG_TIMER;		// ŐVG[R[hXV
			m_tgLastErrCallback.fnWrite();											// ^O
		}
	}

	// ------------------------------------------------------------
	// ICxgҋ@
	// ------------------------------------------------------------
	while (RtNotifyEvent(RT_SYSTEM_NOTIFICATIONS | RT_EXIT_NOTIFICATIONS,
		WAIT_FOREVER, &eiEventInfo))
	{
		switch (eiEventInfo.dwNotifyType)
		{
		case TERMINATE:
		{
			// TODO: {vZX͏I܂
			// N[Abv܂
			Cleanup();											// ߂邱Ƃ͂܂
			break;
		}

		case NT_HOST_UP:
			// TODO: RTNCAgɂNTzXg̕AΉ
			break;

		case NT_BLUESCREEN:
			// TODO: Windows̃u[XN[oΉ
			break;

		case KERNEL_STOPPING:
		{
			// TODO: INtimeJ[lT[rX~Ή
			// N[Abv܂
			Cleanup();											// ߂邱Ƃ͂܂
			break;
		}

		case NT_HOST_HIBERNATE:
			// TODO: WindowszXg̋x~ԈڍsΉ
			break;

		case NT_HOST_STANDBY:
			// TODO: WindowszXg̃X^oCԈڍsΉ
			break;

		case NT_HOST_SHUTDOWN_PENDING:
		{
			// TODO: WindowszXg̃Vbg_EΉ
			// N[Abv܂
			Cleanup();											// ߂邱Ƃ͂܂
			break;
		}

		}
	}
	Fail("Notify failed");

	return 0;
}
