/*****************************************************************************
*
* FILE NAME:		ThreadDB.h
*
* DESCRIPTION:		RT-edge DBRei DBXbhW[
*
*                   Copyright(C) 2020 Micronet Co.All Rights Reserved.
\*****************************************************************************/
#include <iostream>
#include <string>
#include <list>
#include <vector>

#include <rtpp.h>
#include <RtDbaL.h>

#include "StopWatch.h"
#include "CString.h"

#include "egAPI.h"

using namespace std;


// ------------------------------------------------------------
// DBe[uJ
// ------------------------------------------------------------
#define	NM_EgDBA_TABLE_MEASURE_ID		"measure_id"		// vID
#define	NM_EgDBA_TABLE_MEASURE_DATE		"measure_date"		// v
#define	NM_EgDBA_TABLE_MEASURE_MSEC		"measure_msec"		// v~b


// ------------------------------------------------------------
// DB
// ------------------------------------------------------------
typedef enum {
	EN_EgDBA_DB_STATE_Init = 0,								// 
	EN_EgDBA_DB_STATE_WaitRun = 1,							// sJn҂
	EN_EgDBA_DB_STATE_TagRefsOUTCheck = 2,					// TagRefs_OUT`FbN
	EN_EgDBA_DB_STATE_TagRefsOUTRetry = 3,					// TagRefs_OUT`FbNgC
	EN_EgDBA_DB_STATE_TagRefsOUTError = 4,					// TagRefs_OUT`FbNG[
	EN_EgDBA_DB_STATE_TypeCheck = 5,						// f[^^`FbN
	EN_EgDBA_DB_STATE_TypeCheckError = 6,					// f[^^`FbNG[
	EN_EgDBA_DB_STATE_DBOpen = 7,							// DBI[v
	EN_EgDBA_DB_STATE_DBTableRecCheck = 8,					// 擾R[h
	EN_EgDBA_DB_STATE_DBTableExist = 9,						// DBe[u݊mF
	EN_EgDBA_DB_STATE_DBTableConfigCheck = 10,				// DBe[u\mF
	EN_EgDBA_DB_STATE_DBTableConfigMatch = 11,				// DBe[u\v
	EN_EgDBA_DB_STATE_DBTableConfigUnmatch = 12,			// DBe[u\sv
	EN_EgDBA_DB_STATE_DBTableDelete = 13,					// DBe[u폜
	EN_EgDBA_DB_STATE_DBTableCreate = 14,					// DBe[u
	EN_EgDBA_DB_STATE_MeasureIdCheck = 15,					// ID`FbN
	EN_EgDBA_DB_STATE_DBTableInsert = 16,					// DBe[u}
}	EN_EgDBA_DB_STATE_XXXX;


// ------------------------------------------------------------
// DBXbh^ONX
// ------------------------------------------------------------
class CEgDBATagDB : public CEgDBATag
{
public:

	// ------------------------------------------------------------
	// RXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		^O͈Ŏw肳ꂽ^ǑɁuDBvt܂B
	// ------------------------------------------------------------
	CEgDBATagDB(void);

	// ------------------------------------------------------------
	// fXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	~CEgDBATagDB(void);

	// ------------------------------------------------------------
	// ^O̐
	// [param]
	//		*chName ... ^O
	//		woType      ... ^O^Cv
	//		*chSource   ... f[^\[X
	//		*chComment  ... Rg
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		^O͈Ŏw肳ꂽ^ȎOɁuSERVICE.EgModbusvt܂B
	// ------------------------------------------------------------
	DWORD	fnCreate(const char *chName, WORD woType, const char *chSource = "", const char *chComment = "");

	// ------------------------------------------------------------
	// ^ÕA^b`
	// [param]
	//		*chName     ... ^O
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		^O͈Ŏw肳ꂽ^ȎOɁuSERVICE.EgDBAvt܂B
	// ------------------------------------------------------------
	void	fnAttach(const char *chName);

};


// ------------------------------------------------------------
// TagRefNX
// ------------------------------------------------------------
class CEgDBATagRef
{
public:
	// ^O
	CEgDBATag							m_tgTag;

	// ------------------------------------------------------------
	// RXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	CEgDBATagRef();

	// ------------------------------------------------------------
	// fXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	~CEgDBATagRef(void);

};


// ------------------------------------------------------------
// DBbhNX
// ------------------------------------------------------------
class CThreadDB : public CISemaphoreThread
{
public:
	// Xbh
	CString								m_srNmTh;
	// Z}tH
	CString								m_srNmSem;
	// Xbh
	INIT_STATE							m_enThSts;

	// ------------------------------------------------------------
	// RXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	CThreadDB();

	// ------------------------------------------------------------
	// fXgN^
	// [param]
	//		Ȃ
	// [return]
	//		Ȃ
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	~CThreadDB(void);

	// ------------------------------------------------------------
	// T[rXvpeB^O̐
	// [param]
	//		Ȃ
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	DWORD	fnCreateTag();

	// ------------------------------------------------------------
	// Z}tHXbh̐
	// [param]
	//		byPrio  ... vCIeB
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		X[u[JXbhŕKvȃp[^ݒANXCreateR[
	// ------------------------------------------------------------
	DWORD	fnCreateThread(BYTE byPrio);

	// ------------------------------------------------------------
	// XbhO
	// [param]
	//		Ȃ
	// [return]
	//		TRUE=/FALSE=s
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	virtual BOOL	InitInstance(void);

	// ------------------------------------------------------------
	// Xbhs
	// [param]
	//		Ȃ
	// [return]
	//		TRUE=Xbhp/FALSE=XbhI
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	virtual BOOL	DoForever(void);

	// ------------------------------------------------------------
	// gKM
	// [param]
	//		Ȃ
	// [return]
	//		TRUE=Xbhp/FALSE=XbhI
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	virtual BOOL	OnReceive(void);

	// ------------------------------------------------------------
	// ԑJ
	// [param]
	//		dwState ... Jڌ̏
	//		boPrint ... true=Oo͂/false=Oo͂Ȃ
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	void fnChangeState(DWORD dwState, bool boPrint = true);

	// ------------------------------------------------------------
	// ԑJ
	// [param]
	//		Ȃ
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	DWORD	fnStateMachine();

	// ------------------------------------------------------------
	// I[v

	// ------------------------------------------------------------
	// N[Y
	// [param]
	//		Ȃ
	// [return]
	//		0=I/̑=G[
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	void	fnClose();

	// ------------------------------------------------------------
	// Xbh㏈
	// [param]
	//		Ȃ
	// [return]
	//		0=G[Ȃ/ȊO=G[
	// [remarks]
	//		Ȃ
	// ------------------------------------------------------------
	virtual int		ExitInstance(void);

private:
	// O
	CEgDBALog							m_Log;
	// TagRefsOutXg
	vector<CEgDBATagRef>				m_TagRefsOut;
	// 
	StopWatch							m_swBase;
	// DBڑnh
	RTHANDLE							m_hnCnDb;

	// VXe
	struct	timeval						m_stTv;
	// VXe
	struct	__timezone					m_stTz;
	// VXe
	struct	tm							*m_stTm;

	// ^OF^Oo^`FbN^CAEg(b)
	CEgDBATag							m_tgTagCheckTimeout;
	// ^OFDBe[u݂ꍇ̏
	CEgDBATag							m_tgTableDelete;
	// ^OFDBe[u\sv̏ꍇ̏
	CEgDBATag							m_tgTableUnmatch;
	// ^OFDBe[uő[
	CEgDBATag							m_tgTableRecMax;


	// ^OFN
	CEgDBATagDB							m_tgSuspend;
	// ^OFŐṼG[R[h
	CEgDBATagDB							m_tgLastErr;
	// ^OFRSI-DBÃG[R[h
	CEgDBATagDB							m_tgDBAErr;
	// ^OFғJE^
	CEgDBATagDB							m_tgLive;
	// ^OF
	CEgDBATagDB							m_tgState;
	// ^OFڑ
	CEgDBATagDB							m_tgConnected;
	// ^OFDBڑ
	CEgDBATagDB							m_tgConnectedOpen;
	// ^OFDBڑ
	CEgDBATagDB							m_tgConnectedSucc;
	// ^OFMODBUS/TCPւ̐ڑؒf
	CEgDBATagDB							m_tgConnectedFail;
	// ^OFMODBUS/TCPւ̐ڑؒf
	CEgDBATagDB							m_tgConnectedClose;
	// ^OFϒʐMTCN^C(ms)
	CEgDBATagDB							m_tgCycletime;
	// ^OFŒZʐMTCN^C(ms)
	CEgDBATagDB							m_tgCyclemin;
	// ^OFŒʐMTCN^C(ms)
	CEgDBATagDB							m_tgCyclemax;
	// ^OFvID
	CEgDBATagDB							m_tgMeasureId;
	// ʐMptH[}XNX
	PerfMon								m_perfComm;

};



