/*****************************************************************************
*
* FILE NAME:		ThreadTimer.cpp
*
* DESCRIPTION:		RT-edge DBRei ^C}[XbhW[
*
*                   Copyright(C) 2020 Micronet Co. All Rights Reserved.
\*****************************************************************************/

#include "EgDBA.h"
#include "ThreadTimer.h"
#include "ThreadDB.h"


// ------------------------------------------------------------
// RXgN^
CEgDBATagTimer::CEgDBATagTimer()
{
}

// ------------------------------------------------------------
// fXgN^
CEgDBATagTimer::~CEgDBATagTimer(void)
{
}

// ------------------------------------------------------------
// ^O̐
DWORD	CEgDBATagTimer::fnCreate(const char *chName, WORD woType, const char *chSource, const char *chComment)
{
	CString			srName;
	srName.Format("%s.Timer", chName);
	return CEgDBATag::fnCreate(srName.c_str(), woType, chSource, chComment);
}


// ------------------------------------------------------------
// RXgN^
CThreadTimer::CThreadTimer()
{
	// XbhXe[^XXV
	m_enThSts = BEFORE_INIT;

	// ^OtbV
	m_dwCycle = DEF_CYCLE;

}

// ------------------------------------------------------------
// fXgN^
CThreadTimer::~CThreadTimer()
{
}

// ------------------------------------------------------------
// T[rXvpeB^O̐
DWORD	CThreadTimer::fnCreateTag()
{
	// OIuWFNg̏
	m_Log.m_srObj.Format("TIMER");

	// ------------------------------------------------------------
	// ^O̐FT[rXCWP[^F^OtbV
	m_tgIndRun.fnAttach("Run");

	// ------------------------------------------------------------
	// ^O̐FT[rXCWP[^FG[
	m_tgIndError.fnAttach("Error");

	// ------------------------------------------------------------
	// ^O̐FT[rXCWP[^FT[rXғJE^
	m_tgIndLive.fnAttach("Live");

	// ------------------------------------------------------------
	// ^O̐FN
	m_tgSuspend.fnCreate("Suspend", EgVtBoolean, "", "true=run/false=suspend");

	// ------------------------------------------------------------
	// ^O̐FŐṼG[R[h
	m_tgLastErr.fnCreate("LastErr", EgVtUInt32, "", "");

	// ------------------------------------------------------------
	// X[u[JXbhgKʒm
	m_tgTrigger.fnCreate("Trigger", EgVtUInt32, "", "");

	// ------------------------------------------------------------
	// X[u[JXbhx
	m_tgDelay.fnCreate("Delay", EgVtBoolean, "", "true = delay / false = no delay");

	// ------------------------------------------------------------
	// X[u[JXbhxJE^
	m_tgDelayCtr.fnCreate("DelayCount", EgVtUInt32, "", "");

	// ------------------------------------------------------------
	// ^O̐FғJE^
	m_tgLive.fnCreate("Live", EgVtUInt32, "", "");

	// ------------------------------------------------------------
	// ^ÕA^b`FR[obNFN
	m_tgSuspendCallback.fnAttach("Suspend.Callback");

	return ERR_EGDBA_OK;
}

// ------------------------------------------------------------
// DBXbhgK̃bNAbv
DWORD	CThreadTimer::fnLookupDBTrg()
{
	DWORD			dwRet = ERR_EGDBA_OK;					// ߂l
	CString			srNmSem;								// [JXbhgK

	// Z}tH̐
	srNmSem.Format("%s", NM_EGDBA_SEMDB);
	// Z}tH̃bNAbv
	dwRet = m_DBTrg.Lookup((char*)srNmSem.c_str(), 0);
	if (dwRet != E_OK) {								// bNAbvs
		m_Log.m_srMsg.Format("Lookup %s 0x%08X", srNmSem.c_str(), dwRet);
		m_Log.fnPirnt(EG_LOG_FER, __LINE__);
	}

	return dwRet;
}

// ------------------------------------------------------------
// DBXbh^ÕA^b`
DWORD	CThreadTimer::fnAttachDBTag()
{
	DWORD			dwRet = ERR_EGDBA_OK;					// ߂l

	// ^OFNԂ̃A^b`
	m_tgSuspendDB = new CEgDBATagDB();						// ^ONX̍쐬
	m_tgSuspendDB->fnAttach("Suspend");						// ^ÕA^b`

	// ^OFڑԂ̃A^b`
	m_tgConnectedDB = new CEgDBATagDB();					// ^ONX̍쐬
	m_tgConnectedDB->fnAttach("Connected");					// ^ÕA^b`

	return dwRet;
}

// ------------------------------------------------------------
// Xbh̐
DWORD	CThreadTimer::fnCreateThread(BYTE byPrio, DWORD dwCycle)
{
	// ^OtbVXV
	m_dwCycle = dwCycle;

	// Xbh̐
	m_srNmTh.Format("%s", NM_EGDBA_THTIMER);

	// NXR[
	return CIPollThread::Create((char*)m_srNmTh.c_str(), m_dwCycle, byPrio);
}

// ------------------------------------------------------------
// XbhO
BOOL	CThreadTimer::InitInstance(void)
{
	// T[rXCWP[^sԂ̍XV
	m_tgIndRun.m_unData.boVal = FALSE;
	m_tgIndRun.fnWrite();

	// T[rXCWP[^G[Ԃ̍XV
	m_tgIndError.m_unData.boVal = FALSE;
	m_tgIndError.fnWrite();

	// XbhXe[^XXV
	m_enThSts = INIT_DONE;

	// NXR[
	return CIPollThread::InitInstance();
}

// ------------------------------------------------------------
// Xbhs
BOOL	CThreadTimer::OnPoll(void)
{
	DWORD			dwRet = ERR_EGDBA_OK;					// ߂l
	BOOL			boDelay = FALSE;						// ftHg͒xȂ

	// ------------------------------------------------------------
	// ғJE^CNg
	// ------------------------------------------------------------
	m_tgIndLive.m_unData.dwVal++;
	m_tgIndLive.fnWrite();
	m_tgLive.m_unData.dwVal++;
	m_tgLive.fnWrite();										// ^Ȍ

	// ------------------------------------------------------------
	// DBXbhւ̃gKʒm
	// ------------------------------------------------------------
	// T[rXCWP[^sԂ̔
	if (m_tgIndRun.m_unData.boVal == TRUE)
	{
		m_tgTrigger.m_unData.dwVal++;						// gKʒm񐔃CNg
		m_tgTrigger.fnWrite();								// ^O
		dwRet = m_DBTrg.Release();							// gKʒm
		switch (dwRet)
		{
		case E_OK:											// I
			break;
		case E_LIMIT:										// x(DBXbhZ}tH擾ĂȂ)
			boDelay = TRUE;									// x
			m_tgDelayCtr.m_unData.dwVal++;					// xJE^CNg
			m_tgDelayCtr.fnWrite();							// ^O
			m_tgLastErr.m_unData.dwVal = ERR_EGDBA_DETECT_SLAVE_DELAY;			// ŐVG[R[hXV
			m_tgLastErr.fnWrite();												// ^O
			break;
		default:											// ȊO
			boDelay = TRUE;									// x
			m_Log.m_srMsg.Format("Release DB trigger 0x%08X", dwRet);
			m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
			m_tgLastErr.m_unData.dwVal = ERR_EGDBA_TRG_TIMER;					// ŐVG[R[hXV
			m_tgLastErr.fnWrite();												// ^O
			return FALSE;									// ss
			break;
		}
	}

	// xԔ
	if (m_tgDelay.m_unData.boVal != boDelay) {				// Oƕω
		m_tgDelay.m_unData.boVal = boDelay;					// xԍXV
		m_tgDelay.fnWrite();								// ^O
	}

	// ------------------------------------------------------------
	// T[rXCWP[^G[ԍXV
	// ------------------------------------------------------------
	OnErrCheck();

	return TRUE;											// s
}

// ------------------------------------------------------------
// G[ԃ`FbN
void	CThreadTimer::OnErrCheck(void)
{

	BOOL boError = FALSE;									// TURE=G[/FALSE=G[Ȃ
	// R[obN~H
	m_tgSuspendCallback.fnRead();
	if (TRUE == m_tgSuspendCallback.m_unData.boVal) { boError = TRUE; }
	// ^C~OXbh~H
	m_tgSuspend.fnRead();
	if (TRUE == m_tgSuspend.m_unData.boVal) { boError = TRUE; }
	// DBXbh~H
	m_tgSuspendDB->fnRead();
	if (TRUE == m_tgSuspendDB->m_unData.boVal) { boError = TRUE; }
	// DBXbh̐ڑԂڑH
	m_tgConnectedDB->fnRead();
	if (FALSE == m_tgConnectedDB->m_unData.boVal) { boError = TRUE; }
	// x
	if (TRUE == m_tgDelay.m_unData.boVal) { boError = TRUE; }
	// G[Ԕ
	if (m_tgIndError.m_unData.boVal != boError) {			// Oƕω
		m_tgIndError.m_unData.boVal = boError;				// T[rXCWP[^G[Ԃ̍XV
		m_tgIndError.fnWrite();								// ^Ȍ
	}

}

// ------------------------------------------------------------
// Xbh㏈
int		CThreadTimer::ExitInstance(void)
{
	m_tgSuspend.m_unData.boVal = TRUE;							// NԍXV
	m_tgSuspend.fnWrite();										// ^Ȍ

	// T[rXCWP[^sԂ̍XV
	m_tgIndRun.m_unData.boVal = FALSE;
	m_tgIndRun.fnWrite();

	// T[rXCWP[^G[Ԃ̍XV
	m_tgIndError.m_unData.boVal = TRUE;
	m_tgIndError.fnWrite();

	// NXR[
	return CIPollThread::ExitInstance();
}

// ------------------------------------------------------------
// ^OtbVJn
DWORD	CThreadTimer::fnStart()
{
	DWORD			dwRet = ERR_EGDBA_OK;

	m_Log.m_srMsg.Format("Cycle start");
	m_Log.fnPirnt(EG_LOG_OPE, __LINE__);

	// T[rXCWP[^̍XV
	m_tgIndRun.m_unData.boVal = TRUE;
	m_tgIndRun.fnWrite();

	return dwRet;
}

// ------------------------------------------------------------
// ^OtbV~
void	CThreadTimer::fnStop()
{
	m_Log.m_srMsg.Format("Cycle stop");
	m_Log.fnPirnt(EG_LOG_OPE, __LINE__);

	// T[rXCWP[^̍XV
	m_tgIndRun.m_unData.boVal = FALSE;
	m_tgIndRun.fnWrite();
}

// ------------------------------------------------------------
// ^OtbVXV
DWORD	CThreadTimer::fnUpdate()
{
	DWORD			dwRet;
	BOOL			boDelay = FALSE;						// ftHg͒xȂ

	m_Log.m_srMsg.Format("Update");
	m_Log.fnPirnt(EG_LOG_OPE, __LINE__);

	// gKʒm
	dwRet = m_DBTrg.Release();
	switch (dwRet)
	{
	case E_OK:												// I
		break;
	case E_LIMIT:											// x(DBXbhZ}tH擾ĂȂ)
		boDelay = TRUE;										// x
		m_Log.m_srMsg.Format("Release DB trigger E_LIMIT" );
		m_Log.fnPirnt(EG_LOG_WRN, __LINE__);
		m_tgDelayCtr.m_unData.dwVal++;						// xJE^CNg
		m_tgDelayCtr.fnWrite();								// ^O
		m_tgLastErr.m_unData.dwVal = ERR_EGDBA_DETECT_SLAVE_DELAY;			// ŐVG[R[hXV
		m_tgLastErr.fnWrite();												// ^O
		dwRet = E_OK;										// ߂l𐳏IɍXV
		break;
	default:												// ȊO
		boDelay = TRUE;										// x
		m_Log.m_srMsg.Format("Release DB trigger 0x%08X", dwRet);
		m_Log.fnPirnt(EG_LOG_ERR, __LINE__);
		break;
	}

	// xԔ
	if (m_tgDelay.m_unData.boVal != boDelay) {				// Oƕω
		m_tgDelay.m_unData.boVal = boDelay;					// xԍXV
		m_tgDelay.fnWrite();								// ^O
	}

	return dwRet;
}
