///////////////////////////////////////////////////////////////////////
// implementation of the CIDataMbxThread class
// last updated: 28oct98
// Copyright(C) 1998 Micronet Co. All Rights Reserved.

#include "rtpp.h"


///////////////////////////////////////////////////////////////////////
// constructor

CIDataMbxThread::	CIDataMbxThread(void)

	: CIThread()
{
}


///////////////////////////////////////////////////////////////////////
// Create
// returns: zero or error code

DWORD CIDataMbxThread::
					Create(
	char *				pszName,
	char *				pszMbx,
	BYTE				byPrio,
	DWORD				dwStack,
	BOOL				bGo)
{
	DWORD			dwResult;

	Detach();

	// create the mailbox, and handle failure properly
	m_status		= m_Mbx.Create(pszMbx);
	if (m_status != E_OK)
		return m_status;

	// create the thread
	dwResult		= CIThread::Create(pszName, byPrio, dwStack, bGo);

	// if the thread creation failed, clean up
	if (dwResult != E_OK)
		m_Mbx.Detach();
	return (m_status = dwResult);
}


///////////////////////////////////////////////////////////////////////
// DoForever
// returns: TRUE if loop should continue, FALSE if thread should terminate

BOOL CIDataMbxThread::
					DoForever(void)
{
	WORD			dwLen;
	BYTE			byBuf[128];
	
	// try to receive a message
	dwLen			= m_Mbx.Receive(byBuf, sizeof(byBuf));
	if (dwLen == 0)
	{
		m_status	= ::GetLastRtError();
		return FALSE;
	}

	// perform message handling
	return OnReceive(byBuf, dwLen);
}


///////////////////////////////////////////////////////////////////////
// ExitInstance
// returns: zero or error code

int CIDataMbxThread::
					ExitInstance(void)
{
	m_Mbx.Detach();
	m_status		= m_Mbx.GetLastError();
	return m_status;
}


///////////////////////////////////////////////////////////////////////

BOOL CIDataMbxThread::
					OnReceive(
	BYTE *				pBuffer,
	WORD				wLen)
{
	return TRUE;
}
