///////////////////////////////////////////////////////////////////////
// implementation of the CILLIntMbxHandler class
// last updated: 23Oct07
// Copyright(C) 2007 Micronet Co. All Rights Reserved.


#include "rtpp.h"

///////////////////////////////////////////////////////////////////////
// constructor

CILLIntMbxHandler::	CILLIntMbxHandler(void)

	: CIIntHandler()
{
}


///////////////////////////////////////////////////////////////////////
// destructor

CILLIntMbxHandler::	~CILLIntMbxHandler(void)
{
	// detach the element
	// (code copied here to reach own Delete function)
	if (InternalDetach())
	{
		Delete();
		m_hRTObject	= NULL_RTHANDLE;
	}
}


///////////////////////////////////////////////////////////////////////
// Create
// returns: zero or error code

DWORD CILLIntMbxHandler::
					Create(
	WORD				wLevel,
	CILLMbx *			pMbx,
	BOOL				bShared)
{
	// the mailbox must be attached
	if (pMbx->GetHandle() == NULL_RTHANDLE)
		return (m_status = E_PARAM);

	m_pMbx			= pMbx;
	CIIntHandler::Create(wLevel, bShared);

	return m_status;
}


///////////////////////////////////////////////////////////////////////
// OnInterrupt

BOOL CILLIntMbxHandler::
					OnInterrupt(void)
{
	Send();

	return TRUE;
}


///////////////////////////////////////////////////////////////////////
// Send

void CILLIntMbxHandler::
					Send(void)
{
	m_pMbx->Send("\0", 1);
}
