///////////////////////////////////////////////////////////////////////
// implementation of the CILLIntSemaphoreHandler class
// last updated: 23oct07
// Copyright(C) 2007 Micronet Co. All Rights Reserved.


#include "rtpp.h"

///////////////////////////////////////////////////////////////////////
// constructor

CILLIntSemaphoreHandler::
					CILLIntSemaphoreHandler(void)

	: CIIntHandler()
{
}


///////////////////////////////////////////////////////////////////////
// destructor

CILLIntSemaphoreHandler::
					~CILLIntSemaphoreHandler(void)
{
	// detach the element
	// (code copied here to reach own Delete function)
	if (InternalDetach())
	{
		Delete();
		m_hRTObject	= NULL_RTHANDLE;
	}
}


///////////////////////////////////////////////////////////////////////
// Create
// returns: zero or error code

DWORD CILLIntSemaphoreHandler::
					Create(
	WORD				wLevel,
	CILLSemaphore *		pSem,
	BOOL				bShared)
{
	// the semaphore must be attached
	if (pSem->GetHandle() == NULL_RTHANDLE)
		return (m_status = E_PARAM);

	CIIntHandler::Create(wLevel, bShared);
	m_pSem			= pSem;
	m_cName[0]		= 0;

	return m_status;
}


///////////////////////////////////////////////////////////////////////
// OnInterrupt

BOOL CILLIntSemaphoreHandler::
					OnInterrupt(void)
{
	Release();

	return TRUE;
}


///////////////////////////////////////////////////////////////////////
// Release

void CILLIntSemaphoreHandler::
					Release(void)
{
	m_pSem->Release();
}
