///////////////////////////////////////////////////////////////////////
// implementation of the CILLMbxThread class
// last updated: 28oct98
// Copyright(C) 1998 Micronet Co. All Rights Reserved.

#include "rtpp.h"


///////////////////////////////////////////////////////////////////////
// constructor

CILLMbxThread::		CILLMbxThread(void)

	: CIThread()
{
}


///////////////////////////////////////////////////////////////////////
// Create
// returns: zero or error code

DWORD CILLMbxThread::
					Create(
	char *				pszName,
	CILLMbx *			pMbx,
	DWORD				dwMsgSize,
	BYTE				byPrio,
	DWORD				dwStack,
	BOOL				bGo)
{
	DWORD			dwResult;

	Detach();

	// the mailbox must be attached
	if (pMbx->GetHandle() == NULL_RTHANDLE)
		return (m_status = E_PARAM);
	m_pMbx			= pMbx;

	// allocate a buffer for receiving
	m_dwLen			= dwMsgSize;
	m_pBuffer		= new BYTE[dwMsgSize];
	if (m_pBuffer == NULL)
		return (m_status = E_MEM);

	// create the thread
	dwResult		= CIThread::Create(pszName, byPrio, dwStack, bGo);

	// if the thread creation failed, clean up
	if (dwResult != E_OK)
	{
		delete []m_pBuffer;
	}
	return (m_status = dwResult);
}


///////////////////////////////////////////////////////////////////////
// DoForever
// returns: TRUE if loop should continue, FALSE if thread should terminate

BOOL CILLMbxThread::DoForever(void)
{
	DWORD			dwLen;
	
	// try to receive a message
	dwLen			= m_pMbx->Receive(m_pBuffer, m_dwLen);
	if (dwLen == 0)
	{
		m_status	= ::GetLastRtError();
		return FALSE;
	}

	// perform message handling
	return OnReceive(m_pBuffer, dwLen);
}


///////////////////////////////////////////////////////////////////////
// ExitInstance
// returns: zero or error code

int CILLMbxThread::	ExitInstance(void)
{
	delete [] m_pBuffer;
	return 0;
}


///////////////////////////////////////////////////////////////////////

BOOL CILLMbxThread::OnReceive(
	BYTE *				pBuffer,
	DWORD				dwLen)
{
	return TRUE;
}
