///////////////////////////////////////////////////////////////////////
// implementation of the CILLPIntMbxHandler class
// last updated: 23Oct07
// Copyright(C) 2007 Micronet Co. All Rights Reserved.

#include "rtpp.h"

///////////////////////////////////////////////////////////////////////
// constructor

CILLPIntMbxHandler::	CILLPIntMbxHandler(void)

	: CIPIntHandler()
{
}


///////////////////////////////////////////////////////////////////////
// destructor

CILLPIntMbxHandler::	~CILLPIntMbxHandler(void)
{
	// detach the element
	// (code copied here to reach own Delete function)
	if (InternalDetach())
	{
		Delete();
		m_hRTObject	= NULL_RTHANDLE;
	}
}


///////////////////////////////////////////////////////////////////////
// Create
// returns: zero or error code

DWORD CILLPIntMbxHandler::
					Create(
	WORD				wVendor,
	WORD				wDevice,
	WORD				wInstance,
	CILLMbx *			pMbx)
{
	// the mailbox must be attached
	if (pMbx->GetHandle() == NULL_RTHANDLE)
		return (m_status = E_PARAM);

	m_pMbx			= pMbx;
	CIPIntHandler::Create(wVendor, wDevice, wInstance);

	return m_status;
}


///////////////////////////////////////////////////////////////////////
// OnInterrupt

BOOL CILLPIntMbxHandler::
					OnInterrupt(void)
{
	Send();

	return TRUE;
}


///////////////////////////////////////////////////////////////////////
// Send

void CILLPIntMbxHandler::
					Send(void)
{
	m_pMbx->Send("\0", 1);
}
