///////////////////////////////////////////////////////////////////////
// implementation of the CILLPIntSemaphoreHandler class
// last updated: 23Oct07
// Copyright(C) 2007 Micronet Co. All Rights Reserved.


#include "rtpp.h"

///////////////////////////////////////////////////////////////////////
// constructor

CILLPIntSemaphoreHandler::
					CILLPIntSemaphoreHandler(void)

	: CIPIntHandler()
{
}


///////////////////////////////////////////////////////////////////////
// destructor

CILLPIntSemaphoreHandler::
					~CILLPIntSemaphoreHandler(void)
{
	// detach the element
	// (code copied here to reach own Delete function)
	if (InternalDetach())
	{
		Delete();
		m_hRTObject	= NULL_RTHANDLE;
	}
}


///////////////////////////////////////////////////////////////////////
// Create
// returns: zero or error code

DWORD CILLPIntSemaphoreHandler::
					Create(
	WORD				wVendor,
	WORD				wDevice,
	WORD				wInstance,
	CILLSemaphore *		pSem)
{
	// the semaphore must be attached
	if (pSem->GetHandle() == NULL_RTHANDLE)
		return (m_status = E_PARAM);

	CIPIntHandler::Create(wVendor, wDevice, wInstance);
	m_pSem			= pSem;
	m_cName[0]		= 0;

	return m_status;
}


///////////////////////////////////////////////////////////////////////
// OnInterrupt

BOOL CILLPIntSemaphoreHandler::
					OnInterrupt(void)
{
	Release();

	return TRUE;
}


///////////////////////////////////////////////////////////////////////
// Release

void CILLPIntSemaphoreHandler::
					Release(void)
{
	m_pSem->Release();
}
