///////////////////////////////////////////////////////////////////////
// implementation of the CILLSemaphore class
// last updated: 28oct98
// Copyright(C) 1998 Micronet Co. All Rights Reserved.

#include "rtpp.h"


///////////////////////////////////////////////////////////////////////
// constructor

CILLSemaphore::		CILLSemaphore(void)

	: CIObject(CITYPE_LLSEMAPHORE)
{
}


///////////////////////////////////////////////////////////////////////
// destructor

CILLSemaphore::		~CILLSemaphore(void)
{
	// detach the element
	// (code copied here to reach own Delete function)
	if (InternalDetach())
		Delete();
}


///////////////////////////////////////////////////////////////////////
// Create

DWORD CILLSemaphore::
					Create(
	DWORD				dwFlags)
{
	// detach from RT object
	Detach();

	// create the low level mailbox
	m_hLLObject		= ::knCreateRtSemaphore((KNPTR)m_Area,
						dwFlags);

	// now set the RT handle
	m_hRTObject		= BAD_RTHANDLE;
	m_bOwner		= TRUE;
	m_cName[0]		= 0;

	return (m_status = E_OK);
}


///////////////////////////////////////////////////////////////////////
// Release
// returns: zero or error code

DWORD CILLSemaphore::
					Release(void)
{
	if (m_hRTObject == NULL_RTHANDLE)
		m_status	= E_EXIST;

	else
	{
		::knReleaseRtSemaphore(m_hLLObject);
		m_status	= E_OK;
	}

	return m_status;
}


///////////////////////////////////////////////////////////////////////
// Wait
// returns: zero or error code

DWORD CILLSemaphore::
					Wait(
	DWORD				dwUsecs)
{
	if (m_hRTObject == NULL_RTHANDLE)
		m_status	= E_EXIST;

	else
	{
		if (!::knWaitForRtSemaphore(m_hLLObject,
				CIApp::GetApp()->UsecsToKticks(dwUsecs)))
			m_status= ::GetLastRtError();
		else
			m_status= E_OK;
	}
	return m_status;
}


///////////////////////////////////////////////////////////////////////
// Delete (protected)

void CILLSemaphore::
					Delete(void)
{
	// get rid of the low level semaphore object
	if (m_hRTObject != NULL_RTHANDLE)
	{
		::knDeleteRtSemaphore(m_hLLObject);
		m_status= E_OK;
	}
	else
		m_status	= E_PARAM;

	// do base class deletion
	CIObject::Delete();
}
