///////////////////////////////////////////////////////////////////////
// implementation of the CILLSemaphoreThread class
// last updated: 28oct98
// Copyright(C) 1998 Micronet Co. All Rights Reserved.


#include "rtpp.h"


///////////////////////////////////////////////////////////////////////
// constructor

CILLSemaphoreThread::
					CILLSemaphoreThread(void)

	: CIThread()
{
}


///////////////////////////////////////////////////////////////////////
// Create
// returns: zero or error code

DWORD CILLSemaphoreThread::
					Create(
	char *				pszName,
	CILLSemaphore *		pSem,
	BYTE				byPrio,
	DWORD				dwStack,
	BOOL				bGo)
{
	Detach();

	// the semaphore must be attached
	if (pSem->GetHandle() == NULL_RTHANDLE)
		return (m_status = E_PARAM);
	m_pSemaphore	= pSem;

	// create the thread
	m_status		= CIThread::Create(pszName, byPrio, dwStack, bGo);
	return m_status;
}


///////////////////////////////////////////////////////////////////////
// DoForever
// returns: TRUE if loop should continue, FALSE if thread should terminate

BOOL CILLSemaphoreThread::
					DoForever(void)
{
	// try to receive a unit
	if (m_pSemaphore->Wait() == WAIT_FAILED)
	{
		m_status	= ::GetLastRtError();
		return FALSE;
	}

	// perform message handling
	return OnReceive();
}


///////////////////////////////////////////////////////////////////////

BOOL CILLSemaphoreThread::
					OnReceive(void)
{
	return TRUE;
}
