///////////////////////////////////////////////////////////////////////
// implementation of the CIObjectMbxThread class
// last updated: 28oct98
// Copyright(C) 1998 Micronet Co. All Rights Reserved.


#include "rtpp.h"


///////////////////////////////////////////////////////////////////////
// constructor

CIObjectMbxThread::	CIObjectMbxThread(void)

	: CIThread()
{
}


///////////////////////////////////////////////////////////////////////
// Create
// returns: zero or error code

DWORD CIObjectMbxThread::
					Create(
	char *				pszName,
	char *				pszMbx,
	BYTE				byPrio,
	DWORD				dwStack,
	BOOL				bGo)
{
	DWORD			dwResult;

	Detach();

	// create the mailbox, and handle failure properly
	m_status		= m_Mbx.Create(pszMbx);
	if (m_status != E_OK)
		return m_status;

	// create the thread
	dwResult		= CIThread::Create(pszName, byPrio, dwStack, bGo);

	// if the thread creation failed, clean up
	if (dwResult != E_OK)
		m_Mbx.Detach();
	return (m_status = dwResult);
}


///////////////////////////////////////////////////////////////////////
// DoForever
// returns: TRUE if loop should continue, FALSE if thread should terminate

BOOL CIObjectMbxThread::
					DoForever(void)
{
	CIObject *		pReply;
	CIObject *		pObject;
	BOOL			bResult;
	
	// try to receive a message
	pObject			= m_Mbx.Receive(&pReply);
	if (pObject == NULL)
	{
		m_status	= ::GetLastRtError();
		return FALSE;
	}

	// perform message handling
	bResult			= OnReceive(pObject, pReply);
	delete pObject;
	delete pReply;
	return bResult;
}


///////////////////////////////////////////////////////////////////////
// ExitInstance
// returns: zero or error code

int CIObjectMbxThread::
					ExitInstance(void)
{
	m_Mbx.Detach();
	m_status		= m_Mbx.GetLastError();
	return m_status;
}


///////////////////////////////////////////////////////////////////////

BOOL CIObjectMbxThread::
					OnReceive(
	CIObject *			pObject,
	CIObject *			pReply)
{
	return TRUE;
}
