///////////////////////////////////////////////////////////////////////
// implementation of the CIRegion class
// last updated: 28oct98
// Copyright(C) 1998 Micronet Co. All Rights Reserved.

#include "rtpp.h"


///////////////////////////////////////////////////////////////////////
// constructor

CIRegion::			CIRegion(void)

	: CIObject(CITYPE_REGION)
{
}


///////////////////////////////////////////////////////////////////////
// destructor

CIRegion::			~CIRegion(void)
{
	// detach the RT object
	// (code copied here to reach own Delete function)
	if (InternalDetach())
		Delete();
}


///////////////////////////////////////////////////////////////////////
// Create
// returns: zero or error code

DWORD CIRegion::	Create(
	char *				pszName,
	BOOL				bPrioQ)
{
	RTHANDLE		h;

	// detach from RT object
	Detach();

	// create the region
	h				= ::CreateRtRegion(
						(bPrioQ ? PRIORITY_QUEUING : FIFO_QUEUING));
	if (h == BAD_RTHANDLE)
		return (m_status = ::GetLastRtError());

	// attach the RT region object (as owner)
	m_status		= E_OK;
	InternalAttach(pszName, h, TRUE);

	return m_status;
}


///////////////////////////////////////////////////////////////////////
// Release
// returns: zero or error code

DWORD CIRegion::	Release(void)
{
	if (m_hRTObject == NULL_RTHANDLE)
		m_status	= E_EXIST;

	else if (::ReleaseRtControl())
		m_status	= E_OK;

	else
		m_status	= ::GetLastRtError();

	return m_status;
}


///////////////////////////////////////////////////////////////////////
// Wait
// returns: zero or error code

DWORD CIRegion::	Wait(
	DWORD				dwTimeout)
{
	BOOL			bResult;

	if (m_hRTObject == NULL_RTHANDLE)
		return (m_status	= E_EXIST);

	// select proper RT function
	if (dwTimeout == NO_WAIT)
		bResult		= AcceptRtControl(m_hRTObject);
	else if (dwTimeout == WAIT_FOREVER)
		bResult		= WaitForRtControl(m_hRTObject);
	else
		return (m_status = E_PARAM);

	if (bResult)
		m_status	= E_OK;
	else
		m_status= ::GetLastRtError();

	return m_status;
}


///////////////////////////////////////////////////////////////////////
// Delete (protected)

void CIRegion::		Delete(void)
{
	// get rid of the RT region object
	if (m_hRTObject == NULL_RTHANDLE)
		if (::DeleteRtRegion(m_hRTObject))
			m_status= E_OK;
		else
			m_status= ::GetLastRtError();
	else
		m_status	= E_PARAM;

	// do base class deletion
	CIObject::Delete();
}
