///////////////////////////////////////////////////////////////////////
// implementation of the CISemaphoreThread class
// last updated: 28oct98
// Copyright(C) 1998 Micronet Co. All Rights Reserved.


#include "rtpp.h"


///////////////////////////////////////////////////////////////////////
// constructor

CISemaphoreThread::	CISemaphoreThread(void)

	: CIThread()
{
}


///////////////////////////////////////////////////////////////////////
// Create
// returns: zero or error code

DWORD CISemaphoreThread::
					Create(
	char *				pszName,
	char *				pszSema,
	WORD				wMax,
	BYTE				byPrio,
	DWORD				dwStack,
	BOOL				bGo)
{
	DWORD			dwResult;

	Detach();

	// create the semaphore, and handle failure properly
	m_status		= m_Semaphore.Create(pszSema, wMax);
	if (m_status != E_OK)
		return m_status;

	// create the thread
	dwResult		= CIThread::Create(pszName, byPrio, dwStack, bGo);

	// if the thread creation failed, clean up
	if (dwResult != E_OK)
		m_Semaphore.Detach();
	return (m_status = dwResult);
}


///////////////////////////////////////////////////////////////////////
// DoForever
// returns: TRUE if loop should continue, FALSE if thread should terminate

BOOL CISemaphoreThread::
					DoForever(void)
{
	// try to receive a unit
	if (m_Semaphore.Wait() == WAIT_FAILED)
	{
		m_status	= ::GetLastRtError();
		return FALSE;
	}

	// perform message handling
	return OnReceive();
}


///////////////////////////////////////////////////////////////////////
// ExitInstance
// returns: zero or error code

int CISemaphoreThread::
					ExitInstance(void)
{
	m_Semaphore.Detach();
	m_status		= m_Semaphore.GetLastError();
	return m_status;
}


///////////////////////////////////////////////////////////////////////

BOOL CISemaphoreThread::
					OnReceive(void)
{
	return TRUE;
}
