/*----------------------------------------------------------------

	INtime general purpose circular buffer class


		Copyright(C) programed by Kazumix ,Micronet 2015

------------------------------------------------------------------*/
#pragma once
#include <rtpp.h>
#include <string.h>				// for memcpy
#include <assert.h>				// for assert
#include "CircularBuffer.h"		// for CCircularBuffer
#include <algorithm>			// for min

using namespace std;

CCircularBuffer::CCircularBuffer( )
{
	Memory			= 0;
	dwAllocSize		= 0;
	Header			= 0;
	m_power			= false;		// ˂ރ[hFftHg
	m_overwrite		= false;		// ㏑[hFftHg
}
CCircularBuffer::~CCircularBuffer()
{
	Delete();
}
// f[^̃|C^Ԃ
LPVOID CCircularBuffer::GetPointer()
{
	// CIMemory͂
	assert( Memory );
	return (BYTE*)GetHeader() + dwHeaderSize;
}
// wb_̃|C^Ԃ
CircularBufferHeader* CCircularBuffer::GetHeader()
{
	// CIMemory͂
	assert( Memory );
	return (CircularBufferHeader*)Memory->GetPointer();
}
// VԂmۂ܂
bool CCircularBuffer::Create( char* name ,DWORD dwMAX )
{
	// ܂CIMemory͂
	assert( Memory==0 );
	dwAllocSize		= ((0xfff+dwMAX+dwHeaderSize) & 0xfffff000);
	Memory			= new CIMemory();
	if( E_OK != Memory->Create( name ,dwAllocSize ) )
	{
		Delete();
		return false;
	}

	// wb_܂
	Header			= (CircularBufferHeader*)Memory->GetPointer();
	Header->SEG		= Memory->GetHandle();
	Header->IN		= 0;
	Header->OUT		= 0;
	Header->MAX		= dwMAX;

	// f[^܂
	Flush();
	return true;
}
// ̃ԂɃA^b`܂
bool CCircularBuffer::Attach( RTHANDLE hMem )
{
	// ܂CIMemory͂
	assert( Memory==0 );
	// ^nhł邱ƂO
	if( ::GetRtHandleType( hMem ) != SEGMENT_TYPE )
		return false;
	Memory			= new CIMemory();
	// A^b`܂
	Memory->Attach( hMem );
	// oϐɃTCYi[
	dwAllocSize	= Memory->GetSize();
	// wb_N
	Header			= (CircularBufferHeader*)Memory->GetPointer();
	return true;
}
// ̃ԂɃA^b`܂iJ^Owj
bool CCircularBuffer::Attach( char* name )
{
	// ܂CIMemory͂
	assert( Memory==0 );
	// ̃ԂɃA^b`܂
	Memory			= new CIMemory();
	if( E_OK != Memory->Lookup( name ,0 ) )
	{
		Delete();
		return false;
	}
	// oϐɃTCYi[
	dwAllocSize	= Memory->GetSize();
	// wb_N
	Header			= (CircularBufferHeader*)Memory->GetPointer();
	return true;
}
// 폜܂
void CCircularBuffer::Delete()
{
	if(Memory)
		delete Memory;
	Memory = 0;
}
// f[^i[܂
bool CCircularBuffer::Push( void* lpItem )
{
	assert( Memory );
	DWORD					in_next;
	bool					overwriteNOW = false;

	in_next	= (GetIN() + 1) % GetMAX();

	// 󂫂ȂȂ炠߂
	if( in_next == GetOUT() )
	{
		if( ! m_overwrite )
			return false;
		else
			overwriteNOW = true;
	}

	((BYTE*)GetPointer())[ GetIN() ] = *(BYTE*)lpItem;

	// i[CfbNXi߂܂
	SetIN( in_next );
	// ㏑Ȃ
	if( overwriteNOW )
		SetOUT( GetIN() + 1 ); 

	return true;
}
// f[^i[܂
bool CCircularBuffer::Push( BYTE byItem )
{
	assert( Memory );
	return Push( &byItem );
}
// f[^o܂
bool CCircularBuffer::Pop( void* lpItem )
{
	assert( Memory );
	DWORD					out_next;

	// Ȃ炠߂
	if( GetIN() == GetOUT() )
		return false;

	out_next	= (GetOUT() + 1) % GetMAX();
	*(BYTE*)lpItem = ((BYTE*)GetPointer())[ GetOUT() ];

	// oCfbNXi߂܂
	SetOUT( out_next );
	return true;
}
// w茏̃f[^o܂
DWORD CCircularBuffer::PopBlock( void* buf ,DWORD size )
{
	assert( Memory );
	DWORD		head ,tail;
	DWORD		block1st ,block2nd ,totalsize;
	/*--- CfbNX擾 */
	tail		= GetIN();
	head		= GetOUT();
	/*--- o\ȃoCgTCY(totalsize)Zo */
	totalsize = GetDataBlockSize( &block1st ,&block2nd );
	// f[^
	if( totalsize == 0 )
		return 0;

	// size=0͑Sf[^o
	if( size == 0 )
		size	= totalsize;

	if( totalsize < size ){
		// wʗ܂ĂȂ̂ŎoȂ
		totalsize = 0;
	}
	else{
		/*--- ~f[^oCgTCY(size)ŃAW */
		if( block1st >= size ){
			// OōςރTCY
			block1st	= size;
			block2nd	= 0;
		}else{
			// 㔼̃TCY
			block2nd	= (block2nd > (size - block1st)) ? size - block1st : block2nd;
		}
		totalsize	= block1st + block2nd;
		
		/*--- ۂ̎o */
		// obt@̑O
		if( block1st ){
			memcpy( buf ,(BYTE*)GetPointer() + head ,block1st);
		}
		// obt@̌㔼
		if( block2nd ){
			memcpy( (BYTE*)buf + block1st ,(BYTE*)GetPointer() ,block2nd);
		}
		// CfbNXi߂
		SetOUT( (head + totalsize) % GetMAX() );
	}
	// ooCgTCYԋp
	return( totalsize );
}
// w茏̃f[^i[܂
DWORD CCircularBuffer::PushBlock( void* buf ,DWORD size )
{
	assert( Memory );
	bool		overwriteNOW = false;
	DWORD		head ,tail ,free;
	DWORD		block1st ,block2nd ,totalsize;
	/*--- CfbNX擾 */
	head		= GetIN();
	tail		= GetOUT();
	free		= GetFreeSize();
	/*--- _O */
	if( size >= GetMAX() )
		return 0;
	/*--- ܂肫Ȃꍇ */
	if( size > free ){
		if( m_overwrite ){
			// ㏑[h
			overwriteNOW = true;
			tail = head;
		}
		else if( m_power ){
			// ˂ރ[h
			size	 = free;
		}
		else{
			// ߂
			return 0;
		}
	}

	/*--- O/㔼i[TCYZo */
	totalsize = GetFreeBlockSize( &block1st ,&block2nd );

	/*--- ~f[^oCgTCY(size)ŃAW */
	if( block1st >= size ){
		// OōςރTCY
		block1st	= size;
		block2nd	= 0;
	}else{
		// 㔼̃TCY
		block2nd	= (block2nd > (size - block1st)) ? size - block1st : block2nd;
	}
	size	= block1st + block2nd;

	// obt@̑O
	if( block1st ){
		memcpy( (BYTE*)GetPointer() + head ,buf ,block1st);
	}
	// obt@̌㔼
	if( block2nd ){
		memcpy( (BYTE*)GetPointer() ,(BYTE*)buf + block1st ,block2nd);
	}
	// CfbNXi߂
	SetIN( (head + size) % GetMAX() );
	// ㏑Ȃ
	if( overwriteNOW )
		SetOUT( GetIN() + 1 ); 
	// i[łoCgTCYԋp
	return( size );
}
// ̃f[^TCY(byte)Zo
DWORD CCircularBuffer::GetDataSize(void)
{
	assert( Memory );
	DWORD	size;
	size = (GetIN()>=GetOUT()) ? (GetIN() - GetOUT()) :  (GetIN() + GetMAX() - GetOUT());
	return size;
}
// 󂫗e(byte)Zo
DWORD CCircularBuffer::GetFreeSize(void)
{
	assert( Memory );
	return GetMAX() - 1 - GetDataSize();
}
// i[CfbNXl擾
DWORD CCircularBuffer::GetIN()
{
	assert( Memory );
	CircularBufferHeader	*h = GetHeader();
	return h->IN;
}
// oCfbNX擾
DWORD CCircularBuffer::GetOUT()
{
	assert( Memory );
	CircularBufferHeader	*h = GetHeader();
	return h->OUT;
}
// i[CfbNXZbg
void CCircularBuffer::SetIN(DWORD newIN)
{
	assert( Memory );
	CircularBufferHeader	*h = GetHeader();
	h->IN = (newIN % (GetMAX()+1));
}
// oCfbNXZbg
void CCircularBuffer::SetOUT(DWORD newOUT)
{
	assert( Memory );
	CircularBufferHeader	*h = GetHeader();
	h->OUT = (newOUT % (GetMAX()+1));
}
// ő吔擾
DWORD CCircularBuffer::GetMAX()
{
	assert( Memory );
	CircularBufferHeader	*h = GetHeader();
	return h->MAX;
}
// NA
void CCircularBuffer::Flush()
{
	assert( Memory );
	// f[^܂
	memset( (BYTE*)GetPointer() ,0xcc ,Memory->GetSize()-dwHeaderSize );		// fill 0xcc

	// CfbNX܂
	SetIN(0);
	SetOUT(0);
}
// ݂邩ǂ𔻒
bool CCircularBuffer::IsAlive()
{
	if( ::GetRtHandleType( Memory->GetHandle() ) == SEGMENT_TYPE )
		return true;
	else
		return false;
}
// AƂĎo\1stubN2ndubN̊eTCYZoBg[^Ԃ
DWORD CCircularBuffer::GetDataBlockSize( DWORD *firstBlockSize ,DWORD *secondBlockSize )
{
	DWORD		head ,tail;
	head		= GetIN();
	tail		= GetOUT();

	if( head == tail )
	{
		// ܂ĂȂ̂ŎoȂ
		*firstBlockSize		= 0;
		*secondBlockSize	= 0;
		return 0;
	}else if( head > tail )
	{
		// 
		*firstBlockSize		= head - tail;
		*secondBlockSize	= 0;
	}else{
		// Q
		*firstBlockSize		= GetMAX() - tail;
		*secondBlockSize	= head;
	}
	// i[łg[^
	return *firstBlockSize + *secondBlockSize;
}
// obt@ӂȂ悤wCfbNXČvZĕԂ
DWORD CCircularBuffer::CalcIndex( DWORD index )
{
	return (index % GetMAX());
}
// AƂĊi[\1stubN2ndubN̊eTCYZoBg[^Ԃ
DWORD CCircularBuffer::GetFreeBlockSize( DWORD *firstBlockSize ,DWORD *secondBlockSize )
{
	DWORD		head ,tail;
	head		= GetIN();
	tail		= GetOUT();

	/*--- i[\ȃTCYZo */
	if( CalcIndex( head+1 ) == tail )
	{
		*firstBlockSize		= 0;
		*secondBlockSize	= 0;
	}else if( head >= tail ){
		*firstBlockSize		= GetMAX() - head - ((tail==0)?1:0);
		*secondBlockSize	= GetFreeSize() - *firstBlockSize;
	}else{
		*firstBlockSize		= GetFreeSize();
		*secondBlockSize	= 0;
	}
	// i[łg[^
	return *firstBlockSize + *secondBlockSize;
}