/*----------------------------------------------------------------

	INtime general purpose circular buffer class


		Copyright(C) programed by Kazumix ,Micronet 2015

------------------------------------------------------------------*/
#pragma once
#include <rtpp.h>

// circular buffer header structure
#pragma pack(push,1)
typedef struct
{
	RTHANDLE	SEG;			// segment handle
	WORD		_reserve;
	DWORD		MAX;			// pointer maximum (size-1)
	DWORD		IN;				// in pointer
	DWORD		OUT;			// out pointer
}CircularBufferHeader;
#pragma pack(pop)

// circular buffer class
class CCircularBuffer
{
private:
	CIMemory					*Memory;		// NX
	CircularBufferHeader		*Header;		// wb_
	DWORD						dwAllocSize;	// mۃTCY
	static const DWORD			dwHeaderSize = (sizeof(CircularBufferHeader)+15)&0xfffffff0;	// wb_TCY(16̔{ɂȂ悤)
public:
	bool						m_power;		// PushBlockp˂ރ[hiftHgj
	bool						m_overwrite;	// Âf[^㏑郂[hiftHgj
public:
	CCircularBuffer();
	~CCircularBuffer();
	bool Create( char* name,DWORD dwMAX=256 );	// J^OtĐ
	bool Attach( char* name );					// J^OČ(擪"vZX"p)
	bool Attach( RTHANDLE hMem );				// nhw肵Č
	void Delete();								// 폜
	bool Push( void* lpItem );					// i[
	bool Push( BYTE byItem );					// i[
	bool Pop( void* lpItem );					// o
	DWORD PushBlock( void* lpBuf ,DWORD size );	// ubNi[
	DWORD PopBlock( void* lpBuf ,DWORD size );	// ubNŎo

	DWORD CalcIndex( DWORD index );				// obt@ӂȂ悤wCfbNXČvZĕԂ

	DWORD GetDataSize(void);					// ̃TCY
	DWORD GetFreeSize(void);					// 󂫃TCY
	DWORD GetIN();								// IN|C^̎擾
	DWORD GetOUT();								// OUT|C^̎擾
	DWORD GetMAX();								// MAX̎擾
	void SetIN(DWORD newIN);					// IN|C^̐ݒ
	void SetOUT(DWORD newOUT);					// OUT|C^̐ݒ
	void Flush();								// ɂ

	CircularBufferHeader* GetHeader();			// wb_̎擾
	LPVOID GetPointer();						// f[^̎擾
	bool IsAlive();								// Lȃobt@
	// AƂĎo\1stubN2ndubN̊eTCYZoBg[^Ԃ
	DWORD GetDataBlockSize( DWORD *firstBlockSize ,DWORD *secondBlockSize );
	// AƂĊi[\1stubN2ndubN̊eTCYZoBg[^Ԃ
	DWORD GetFreeBlockSize( DWORD *firstBlockSize ,DWORD *secondBlockSize );
};
