/*****************************************************************************
*
* FILE NAME:		DriverClient.cpp
*
* DESCRIPTION:	ėpINtimehCoԃC^[tF[XNCAgNX
*
* REMARKS:			̃NX̓VXeɈˑȂdg݂ō쐬Ă܂B
*
*               Copyright(C) 2020 Micronet Co. All Rights Reserved.
\*****************************************************************************/
#include "DriverClient.h"

// ------------------------------------------------------------
// RXgN^
CDriverClient::CDriverClient() :
	m_bConnected(false),
	m_bRequestNow(false),
	m_Pool(0),
	m_Driver(0),
	m_RespTout(1000)
{
	memset(m_DriverName, 0, sizeof(m_DriverName));
}

// ------------------------------------------------------------
// fXgN^
CDriverClient::~CDriverClient()
{
	Disconnect();
}

// ------------------------------------------------------------
// [{bNX̐ڑ
DWORD CDriverClient::Connect(char * name)
{
	DWORD		dwRet = 0;

	// must be disconnected
	if (m_Driver)
	{
		dwRet = 1;
		goto err;
	}

	// ڑ惁[{bNXRs[
	if (m_DriverName[0] == NULL)
	{
		int inNameLen = strlen(name);
		if (0 == inNameLen)
		{
			// nameݒ
			dwRet = 2;
			goto err;
		}
		else if (inNameLen >= (sizeof(m_DriverName) - 1))
		{
			// name
			dwRet = 3;
			goto err;
		}
		else
		{
			// nameRs[
			strcpy(m_DriverName, name);
		}
	}

	// lookup driver mailbox
	m_Driver = new CIObjectMbx();
	dwRet = m_Driver->Lookup(name, NO_WAIT);
	if (dwRet != E_OK)
		goto err;

	// make memory pool
	m_Pool = new CIMemoryPool();
	m_Pool->MakePool(m_NumQue, m_SizePacket);

	m_bConnected = true;		// ڑm

	return dwRet;

err:
	// driver disconnect
	if (m_Driver)
	{
		delete m_Driver;
		m_Driver = 0;
	}

	// delete memory pool mailbox
	if (m_Pool)
	{
		delete m_Pool;
		m_Pool = 0;
	}

	m_bConnected = false;		// ڑm

	return dwRet;
}

// ------------------------------------------------------------
// [{bNX̐ؒf
DWORD CDriverClient::Disconnect()
{
	// if not yet connected then nothing to do 
	if (!m_bConnected)
		return 1;

	// now disconnected
	m_bConnected = false;

	// delete memory pool mailbox
	if (m_Pool)
	{
		delete m_Pool;
		m_Pool = 0;
	}

	// driver disconnect
	if (m_Driver)
	{
		delete m_Driver;
		m_Driver = 0;
	}

	return 0;
}

// ------------------------------------------------------------
// hCoT[rX֗vB
DWORD CDriverClient::Request(DWORD dwControlCode, DWORD dwUpStreamSize, LPVOID lpUpStream, DWORD * dwDownStreamSize, LPVOID lpDownStream)
{
	RTHANDLE				respmbx;
	RTHANDLE				drvmbx;
	CDriverIfMsgCarrier		*packet;
	DWORD					dwDrvStatus = 0;

	// must be connected
	if (!m_Driver)
	{
		// Đڑ
		dwDrvStatus = Connect(m_DriverName);
		if (0 != dwDrvStatus)
		{
			// Đڑs
			return dwDrvStatus;
		}
	}

	// pick pool (need free)
	packet = (CDriverIfMsgCarrier*)m_Pool->PickPool();
	if (!packet)
		goto err;

	// make packet
	packet->SetRequest(dwControlCode, dwUpStreamSize, lpUpStream);

	// M惁[{bNXnh擾
	drvmbx = m_Driver->GetHandle();

	// request to driver
	m_bRequestNow = true;
	{
		// create responce mailbox
		respmbx = CreateRtMailbox(OBJECT_MAILBOX | FIFO_QUEUING);
		if (respmbx == BAD_RTHANDLE)
			goto err;

		// driver request
		if (TRUE != SendRtHandle(drvmbx, packet->GetHandle(), respmbx))
			goto err;

		// wait responce
		if (BAD_RTHANDLE == ReceiveRtHandle(respmbx, m_RespTout, 0))
			goto err;

	}
	m_bRequestNow = false;

	// delete responce mailbox
	DeleteRtMailbox(respmbx);

	// restore packet
	packet->GetAnswer(&dwDrvStatus, dwDownStreamSize, lpDownStream);

	// return memory to pool
	m_Pool->ReturnPool(packet);

	// MbZ[W̃Xe[^Xԋp
	return dwDrvStatus;

err:
	m_bRequestNow = false;

	// delete responce mailbox
	DeleteRtMailbox(respmbx);

	// return memory to pool
	if (m_Pool)
		m_Pool->ReturnPool(packet);

	// ŐṼG[R[h擾
	dwDrvStatus = GetLastRtError();

	// ŐṼG[R[hE_EXIST͐ؒf
	if (dwDrvStatus == E_EXIST)
	{
		Disconnect();
	}

	// ŐṼG[R[hԋp
	return dwDrvStatus;
}

// ------------------------------------------------------------
// ^CAEgݒ肷
void CDriverClient::SetRespTout(DWORD dwRespTout)
{
	m_RespTout = dwRespTout;
}
