/*----------------------------------------------------------------

	INtime general purpose exception class


		Copyright(C) programed by Kazumix ,Micronet 2015

------------------------------------------------------------------*/
#pragma once
#include <rt.h>
#include <rtpp.h>
#include <string>
#include <iostream>
#include <exception>
#include <string.h>
#include <eh.h>
#include "CString.h"

// {ONX
class BaseException : public std::exception
{
protected:
	std::string		file;	// W[
	std::string		func;	// ֐
	UINT			line;	// sԍ
	DWORD			code;	// G[R[h
	CString			msg;	// bZ[W
public:
	BaseException(const char* fi,const char* fn,UINT l,DWORD c) : file(fi), func(fn), line(l), code(c) ,std::exception() {}	// RXgN^
	virtual const char* what()	// bZ[W
	{
		msg.Format( "%s(%d):%s() 0x%04x" ,file ,line ,func ,code); 
		return msg.c_str();
	}
};


// n[hEFAONX
class HardwareException : public BaseException
{
public:
	DWORD			m_code;	// OR[h
	PVOID			m_addr;	// OAhX
	EXCEPTION_POINTERS		exp;
	unsigned int			u;
private:
	static void transform( unsigned int u, EXCEPTION_POINTERS* pExp );	
public:
    HardwareException( unsigned int v, EXCEPTION_POINTERS* pExp ) // RXgN^
		: u(v)
		,m_code(pExp->ExceptionRecord->ExceptionCode)
		,m_addr(pExp->ExceptionRecord->ExceptionAddress)
		,BaseException("unknown","unknown",0,u)
	{
		memcpy( &exp ,pExp ,sizeof(EXCEPTION_POINTERS) );
	}

	static void Hook();		// n[hEFAÕtbN
	const char* what()		// bZ[W
	{
		msg.Format("HW excep fault %08x\nthread:0x%04x adr:0x%08x"
			,m_code,GetRtThreadHandles(THIS_THREAD),m_addr);
		return msg.c_str();
	}
	const void dump()		// NbV_v
	{
		BYTE		buf[64] ,*idump;
		DWORD		*ddump;
		int			lp1 ,lp2;

		// CPUWX^
		printf("EAX = %08x EBX = %08x ECX = %08x EDX = %08x ESI = %08x\n" ,exp.ContextRecord->Eax ,exp.ContextRecord->Ebx
														,exp.ContextRecord->Ecx ,exp.ContextRecord->Edx
														,exp.ContextRecord->Esi );
		printf("EDI = %08x EIP = %08x ESP = %08x EBP = %08x EFL = %08x\n" ,exp.ContextRecord->Edi ,exp.ContextRecord->Eip
														,exp.ContextRecord->Esp ,exp.ContextRecord->Ebp 
														,exp.ContextRecord->EFlags );
		printf("CS = %04x DS = %04x ES = %04x FS = %04x GS = %04x SS = %04x\n" 
														,exp.ContextRecord->SegCs ,exp.ContextRecord->SegDs
														,exp.ContextRecord->SegEs ,exp.ContextRecord->SegFs
														,exp.ContextRecord->SegGs ,exp.ContextRecord->SegSs);
		// ߃_v
		::CopyRtData( (RTHANDLE)exp.ContextRecord->SegCs ,(LPVOID)exp.ContextRecord->Eip ,0 ,&buf[0] ,sizeof(buf) );
		for( lp1=0,idump=&buf[0] ;lp1<sizeof(buf) ;lp1+=16 )
		{
			printf("\n%04x:%04x  " ,exp.ContextRecord->SegCs ,exp.ContextRecord->Eip+lp1);
			for( lp2=0 ;lp2<16 ;lp2++,idump++ )
				printf("%02x ",*idump);
		}

		// X^bN_v
		::CopyRtData( (RTHANDLE)exp.ContextRecord->SegSs ,(LPVOID)exp.ContextRecord->Esp ,0 ,&buf[0] ,sizeof(buf) );
		for( lp1=0,ddump=(DWORD*)&buf[0] ;lp1<sizeof(buf)/sizeof(DWORD) ;lp1+=4 )
		{
			printf("\n%04x:%04x  " ,exp.ContextRecord->SegSs ,exp.ContextRecord->Esp+lp1);
			for( lp2=0 ;lp2<4 ;lp2++,ddump++ )
				printf("%08x ",(DWORD*)*ddump);
		}
	}
};

// p[^O
class DriverParameterException : public BaseException
{
public:
	DriverParameterException(const char* fi,const char* fn,UINT l,DWORD c):BaseException(fi,fn,l,c){};	// RXgN^
	virtual const char* what() {msg.Format("w$param @ %s" ,BaseException::what());return msg.c_str();}	// bZ[W
};

// O
class DriverEnvironmentException : public BaseException
{
public:
	DriverEnvironmentException(const char* fi,const char* fn,UINT l,DWORD c):BaseException(fi,fn,l,c){};	// RXgN^
	virtual const char* what() {msg.Format("w$env @ %s" ,BaseException::what());return msg.c_str();}		// bZ[W
};


#define	ParamException			DriverParameterException((const char*)__FILE__,(const char*)__FUNCTION__,__LINE__,0)
#define	EnvironmentException	DriverEnvironmentException((const char*)__FILE__,(const char*)__FUNCTION__,__LINE__,GetLastRtError())
