/*----------------------------------------------------------------

	ifcan (Interface PCI4853) INtime driver


			physical memory access helper  class


	   Copyright(C) programed by Kazumix ,Micronet 2016

------------------------------------------------------------------*/
#pragma once

class CIPhysMemory
{
protected:
	// member variables
	LPVOID			m_p;						// mapped pointer
	DWORD			m_dwPhysicalAddress;		// physical address
	DWORD			m_dwLen;					// byte size
	BOOL			m_bCreateOwner;				// owner
	DWORD			m_status;					// last status
public:
	// constructor and destructor
	CIPhysMemory(void);
	CIPhysMemory(DWORD dwPhysAddr, DWORD dwLen);
	~CIPhysMemory(void);

	// member functions for general use
	virtual DWORD	Create(DWORD dwPhysAddr, DWORD dwLen);
	virtual DWORD	Attach(LPVOID p);
 	virtual LPVOID	GetPointer(void);
	virtual DWORD	GetSize(void);
	virtual DWORD	GetPhysicalAddress(void);
	virtual CIPhysMemory &
					operator = (CIPhysMemory & src);
	DWORD GetLastError(void) const;

	// FPGA Low level access functions
	BYTE ReadByte( WORD wOffset );
	WORD ReadWord( WORD wOffset );
	DWORD ReadDword( WORD wOffset );
	void WriteByte( WORD wOffset ,BYTE byVal );
	void WriteWord( WORD wOffset ,WORD wVal );
	void WriteDword( WORD wOffset ,DWORD dwVal );
	DWORD Allocate( DWORD dwSize );

protected:
	// member functions for internal use only
	virtual void	Delete(void);

};

