/*----------------------------------------------------------------

	Gpibif CONTEC GPIB-FL-LPE INtime driver


			COMMON driver request format


	   Copyright(C) programed by Y.K ,Micronet 2020

------------------------------------------------------------------*/
#pragma once

// Driver request code (Gpibif.defEXPORTSŎw肵No˂)
#define		GPIB_CMD_Init					1	// GpInit						GPIB_PACKET_Init
#define		GPIB_CMD_GetAddress				2	// GpGetAddress					GPIB_PACKET_GetAddress
#define		GPIB_CMD_ActiveIFC				3	// GpActiveIFC					GPIB_PACKET_ActiveIFC
#define		GPIB_CMD_SetREN					4	// GpSetREN					GPIB_PACKET_SetREN
#define		GPIB_CMD_ResetREN				5	// GpResetREN					GPIB_PACKET_ResetREN
#define		GPIB_CMD_SetDelimiter			6	// GpSetDelimiter				GPIB_PACKET_SetDelimiter
#define		GPIB_CMD_GetDelimiter			7	// GpGetDelimiter				GPIB_PACKET_GetDelimiter
#define		GPIB_CMD_SetTimeout				8	// GpSetTimeout					GPIB_PACKET_SetTimeout
#define		GPIB_CMD_GetTimeout				9	// GpGetTimeout					GPIB_PACKET_GetTimeout
#define		GPIB_CMD_TransmitCommand		10	// GpTransmitCommand			GPIB_PACKET_TransmitCommand
#define		GPIB_CMD_TransmitData			11	// GpTransmitData				GPIB_PACKET_TransmitData
#define		GPIB_CMD_ReceiveData			12	// GpReceiveData				GPIB_PACKET_ReceiveData
#define		GPIB_CMD_WaitForSRQ				13	// GpWaitForSRQ					GPIB_PACKET_WaitForSRQ
#define		GPIB_CMD_WaitForReceiveEvent	14	// GpWaitForReceiveEvent		GPIB_PACKET_WaitForReceiveEvent
#define		GPIB_CMD_ExecuteSerialpoll		15	// GpExecuteSerialpoll			GPIB_PACKET_ExecuteSerialpoll
#define		GPIB_CMD_ExecuteParallelpoll	16	// GpExecuteParallelpoll		GPIB_PACKET_ExecuteParallelpoll
#define		GPIB_CMD_ConfigureParallelpoll	17	// GpConfigureParallelpoll		GPIB_PACKET_ConfigureParallelpoll
#define		GPIB_CMD_ReadAddressStatus		18	// GpReadAddressStatus			GPIB_PACKET_ReadAddressStatus
#define		GPIB_CMD_ReadSerialpollStatus	19	// GpReadSerialpollStatus		GPIB_PACKET_ReadSerialpollStatus
#define		GPIB_CMD_Lock					20	// GpLock						GPIB_PACKET_Lock
#define		GPIB_CMD_Unlock					21	// GpLock						GPIB_PACKET_Unlock
#define		GPIB_CMD_Exit					22	// GpExit						GPIB_PACKET_Exit
#define		GPIB_CMD__Dump					80	// _GpDump						GPIB_PACKET__Dump

// Driver request content
#pragma pack(push,1)

// 
struct GPIB_PACKET_Init {
	RTHANDLE		hnObj;				// ڑnh
};

// AhX擾
struct GPIB_PACKET_GetAddress {
	BYTE			byAddr;				// 擾AhX
};

// IFC CANeBu
struct GPIB_PACKET_ActiveIFC {
	WORD			woTransTime;		// IFCo(10msP)
};

// REN CZbg
struct GPIB_PACKET_SetREN {
	DWORD			dwReserve;			// (\)
};

// REN CZbg
struct GPIB_PACKET_ResetREN {
	DWORD			dwReserve;			// (\)
};

// f~^Zbg
struct GPIB_PACKET_SetDelimiter {
	BYTE			byDelimiter;		// f~^
};

// f~^擾
struct GPIB_PACKET_GetDelimiter {
	BYTE			byDelimiter;		// f~^
};

// ^CAEglݒ菈
struct GPIB_PACKET_SetTimeout {
	WORD			woTimeout;			// ^CAEg(10msP)
};

// ^CAEgl擾
struct GPIB_PACKET_GetTimeout {
	WORD			woTimeout;			// ^CAEg(10msP)
};

// R}hM
struct GPIB_PACKET_TransmitCommand {
	RTHANDLE		hnCommand;			// MR}h
	WORD			woSize;				// MR}hoCg
};

// f[^M
struct GPIB_PACKET_TransmitData {
	RTHANDLE		hnData;				// Mf[^
	WORD			woSize;				// Mf[^oCg
	WORD			woEOI;				// EOICON/OFF
};

// f[^M
struct GPIB_PACKET_ReceiveData {
	RTHANDLE		hnData;				// Mf[^
	WORD			woSize;				// Mf[^oCg
	WORD			woStore;			// i[ꂽMf[^̃oCg
};

// SRQ ҋ@
struct GPIB_PACKET_WaitForSRQ {
	WORD			woTimeout;			// ^CAEg
};

// MCxgҋ@
struct GPIB_PACKET_WaitForReceiveEvent {
	WORD			woTimeout;			// ^CAEg
};

// VA|[s
struct GPIB_PACKET_ExecuteSerialpoll {
	RTHANDLE		hnPollAddr;			// VA|[s@̃AhX
	WORD			woPollNum;			// VA|[s@퐔
	BYTE			byServAddr;			// T[rXNGXg𔭍sĂ@̃AhX
	BYTE			byServStatus;		// T[rXNGXg𔭍sĂ@̃foCXXe[^X
};

// p|[s
struct GPIB_PACKET_ExecuteParallelpoll {
	BYTE			byStatus;			// Xe[^X
};

// p|[tE
struct GPIB_PACKET_ConfigureParallelpoll {
	RTHANDLE		hnPollAddr;			// @ԍ
	RTHANDLE		hnLineCode;			// CR[h
	WORD			woPollNum;			// @퐔
	BYTE			byUnconfig;			// o͎w(0=Ȃ/1=)
};

// AhXXe[^Xǂݍݏ
struct GPIB_PACKET_ReadAddressStatus {
	BYTE			byStatus;			// AhXXe[^X
};

// VA|[Xe[^Xǂݍݏ
struct GPIB_PACKET_ReadSerialpollStatus {
	BYTE			byStatus;			// VA|[Xe[^X
};

// gp擾
struct GPIB_PACKET_Lock {
	RTHANDLE		hnLock;				// bNnh
};

// gp
struct GPIB_PACKET_Unlock {
	RTHANDLE		hnLock;				// bNnh
};

// I
struct GPIB_PACKET_Exit {
	RTHANDLE		hnObj;				//ʃnh
	DWORD			dwReserve;			// (\)
};

// _v
struct GPIB_PACKET__Dump {
	DWORD			dwReserve;			// (\)
};



#pragma pack(pop)
