/*----------------------------------------------------------------

	INtime general purpose Shared interrupt thread BASE class


		Copyright(C) programed by Kazumix ,Micronet 2015

------------------------------------------------------------------*/
#pragma once
#include <rtpp.h>

// INtime Shared Interrupt Thread class 
class CISharedIntThread : public CIThread
{
public:
	CISharedIntThread(void);
	~CISharedIntThread(void);

	virtual DWORD	Create(char * pszName, WORD wLevel,
						BYTE byMaxInt=1, DWORD dwMilliseconds=WAIT_FOREVER,
						DWORD dwStack=4096);

	// member functions that may be overruled
	virtual BOOL	InitInstance(void);
	virtual BOOL	DoForever(void);
	virtual BOOL	OnInterrupt(void);
	virtual BOOL	OnSignal(BOOL bSignal);
	virtual DWORD	Enable(BOOL bState=TRUE);

	// member functions for internal use only
	virtual void	Delete(void);

protected:
	// member variables
	BYTE			m_byMaxInt;
	WORD			m_wLevel;
	DWORD			m_dwMilliseconds;

private:
	static void SharedInterruptHandler(
		WORD			wCSRA,
		WORD			wLevel,
		LPVOID			pv);
};
