/*****************************************************************************
*
* FILE NAME:		StopWatch.hpp
*
*		INtime Pentium counter helper class
*
*		Copyright(C) programed by Kazumix 2012
*
*
*	// copy constructor
*	StopWatch(StopWatch&);
*
*	// stopwatch control
*	bool Start(void);			// start watch
*	QWORD Stop(void);			// stop watch
*
*	// CPU power
*	DWORD GetCPUSpeed(void);	// 
*
*	// get time value
*	double GetNanosec(void);	// return nsec value 
*	double GetMicrosec(void);	// return usec value 
*	double GetMillisec(void);	// return msec value 
*	double GetSec(void);		// return sec value 
*
\*****************************************************************************/
#pragma once


#ifdef _MICL_RSL_USE
#include "micl.h"
#else
#define	micl_API		// no import
#endif


#include <rt.h>


class micl_API StopWatch
{
public:
	StopWatch(void);
	StopWatch(const StopWatch&);
	~StopWatch(void);
public:
	QWORD		m_Start;
	QWORD		m_Stop;
	QWORD		m_Diff;
	DWORD		m_CPUspeed;		// Hz
public:
	void Start(void);			// start watch
	QWORD Stop(void);			// stop watch
	DWORD GetCPUSpeed(void);	// 

	double GetNanosec(void);
	double GetMicrosec(void);
	double GetMillisec(void);
	double GetSec(void);
private:
	QWORD (*GetPentiumCounter)(void);
	static QWORD GetTSCway1(void);
	static QWORD GetTSCway2(void);
	bool IsInvariantTSCSupport(void);
};


// performance measuring class
class PerfMon : private StopWatch
{
public:
	PerfMon();
	~PerfMon();
public:
	float		m_fMax;			// Œus
	float		m_fMin;			// ŒZus
	float		m_fAve;			// ώus
	QWORD		m_qwCount;		// g[^v
	QWORD		m_qwWhenMax;	// ŌɍŒԂ}[Nۂ̌v
public:
	void Start();		// ptH[}XvX^[g
	void Stop();		// ptH[}XvXgbv
	void Reset();		// ptH[}XṽZbg

	double GetAve(void);	// ώus
	double GetMin(void);	// ŒZus
	double GetMax(void);	// Œus
	QWORD GetCount(void);	// g[^v
};


