/*----------------------------------------------------------------

	INtime general purpose trace ring buffer class


		Copyright(C) programed by Kazumix ,Micronet 2015

------------------------------------------------------------------*/
#include <rtpp.h>
#include <stdio.h>
#include <assert.h>
#include "CircularBuffer.h"
#include "CString.h"
#include "Tracer.h"


Tracer::Tracer() :
	CCircularBuffer()
{
	m_owner		= false;
	m_useRegion	= false;
}
Tracer::~Tracer()
{
}
// VɃg[Xobt@
//		*name ... J^O("\procname\name"or"name")
bool Tracer::Create( char *name )
{
	bool		success;
	CString		str;
	// g[Xobt@𐶐
	success = CCircularBuffer::Create( name ,m_Size );
	if( !success )
		return false;
	// I[i[ɂȂ
	m_owner = true;
	// obt@㏑[hōĐݒ
	m_overwrite	= true;
	// o͔rp[W𐶐
	if( m_useRegion )
	{
		str.Format( "%sR" ,name );
		m_Region.Create( (char*)str.c_str() ,PRIORITY_QUEUING);
	}
	return true;
}
// g[Xobt@ɐڑ
//		*name ... J^O("\procname\name"or"name")
bool Tracer::Attach( char *name )
{
	bool		success;
	CString		str;
	DWORD		status;
	// g[Xobt@ɐڑ
	success = CCircularBuffer::Attach( name );
	if( !success )
		return false;
	// o͔rp[Wɐڑ
	if( m_useRegion )
	{
		str.Format( "%sR" ,name );
		status = m_Region.Lookup( (char*)str.c_str() ,0 );
		if( status != E_OK )
			return false;
	}
	return true;
}
void Tracer::Delete()
{
	CCircularBuffer::Delete();
}
// g[Xo
//		*format ... printf
void Tracer::Trace(char *format, ...)
{
	// use trace?
	if( ! IsActive() )
		return;

	va_list va2;
	char acTable[256];
	int num = sizeof(acTable);

	//va_list va1;
	//char *acTable = 0;						// _Ǌ荞݂̃g[XƂɂ͒ᑬ
	//// Kvȍƃobt@TCYZo
	//va_start(va1, format);
	//num = vsnprintf(NULL, 0, format, va1);
	//va_end(va1);
	//// Kvȍƃobt@m
	//acTable = new char[num+1];

	// ɏ]č\z
	va_start(va2, format);
	num = vsprintf_s(acTable, num+1, format, va2);
	va_end(va2);

	// push message to ring buffer
	if( m_useRegion )
		m_Region.Wait();

	PushBlock( acTable ,num );

	if( m_useRegion )
		m_Region.Release();

	//// ƃobt@
	//if( acTable )
	//	delete [] acTable;
}
// ()g[X
void Tracer::TraceFast(char *msg ,BYTE size)
{
	// use trace?
	if( ! IsActive() )
		return;

	// push message to ring buffer
	if( m_useRegion )
		m_Region.Wait();

	PushBlock( msg ,size );

	if( m_useRegion )
		m_Region.Release();
}
// |[go
bool Tracer::Report()
{
	DWORD		dwSize;
	char		*buf;

	if( ! IsAlive() )
		return false;

	dwSize	= GetDataSize();
	if( dwSize )
	{
		buf = (char*)AllocateRtMemory( (dwSize + 0xfff) & 0xfffff000 );
		PopBlock( buf ,dwSize );
		buf[dwSize]='\0';				// add null charactor
		printf( "%s" ,buf );			// print console
		FreeRtMemory( buf );
	}
	return true;
}
// g[XƂ邩
bool Tracer::IsActive()
{
	return true;
}